/* STRUCTURES, VARIABLES ET PROCEDURES DU PROGRAMME	*/

#include <stdio.h>
#include <stdlib.h>
#include <maclib.proto.h>

#define nmaxfil	10	/* nombre de canaux pour la gestion des fichiers */
#define nmaxcomm	1000	/* nombre de cases comm disponibles	*/
#define nmaxid	2048	/* nombre de numros d'ID disponibles */
#define sizebuff	0x40000	/* mmoire maximale utilise	*/
#define Bloque	flint+=16
#define Debloque	flint-=16
#define flint	(*(int*)FLINT)
#define process	(*(int*)PROCESS)
#define sprocess	(*(int*)SPROCESS)
#define Hot		(proc)2
#define Nid		-1	/* Nid = No ID */
#define Defaut	-2	/* ID non prcis (lors d'un envoi de comm) */


/* dfinition des types de comm utiliss	*/
#define CInt	1	/* entier	*/
#define CLong	2	/* long	*/
#define CPoint	4	/* pointeur	*/
#define CError	8	/* erreur	*/
#define CFile	0x10	/* fichier	*/
#define CMove	0x20	/* couple d'entiers	*/
#define CEnter	0x40	/* entre de zone	*/
#define CQuit	0x80	/* sortie de zone	*/
#define CClick	0x100	/* click	*/
#define CClickE	0x200	/* fin de click	*/
#define CChar	0x400	/* caractre	*/
#define CClock	0x800	/* horloge	*/
#define CData	0x1000	/* buffer	*/
#define CClickn	0x2000	/* n-click	*/

struct Font
	{
	int	larg;	/* largeur de la fonte (<=8)	*/
	int	haut;	/* hauteur de la fonte	*/
	int	msk;	/* (2^larg)-1 */
	char	cod[];	/* table des dessins de la fonte	*/
	};
typedef struct Font	*font;

struct Fen
	{
	int	g;	/* gauche	*/
	int	h;	/* haut	*/
	int	d;	/* droite	*/
	int	b;	/* bas 	*/
	};
typedef struct Fen	*fen;

struct Case
	{
	int	sizec;	/* taille des donnes de la case, en octets	*/
	int	typc;	/* type de la case :
				b0=1 : case  inverser lorsqu'on clique dessus
				b1=1 : objet  dplacer lorsqu'on clique sur la case
				alors b2=0 : dplacer devant
				      b2=1 : dplacer derrire	*/
	int	xcmn;
	int	ycmn;	/* coordonnes de la case : (xcmn,ycmn)-(xcmx,ycmx)	*/
	int	xcmx;
	int	ycmx;
	int	clk;	/* ID destinataire de click (Nid si aucun)	*/
	int	zone;	/* ID destinataire d'entre de zone (Nid si aucun)	*/
	void	(*r[])();	/* ventuels registres utilisateurs	*/
	};	
typedef struct Case	*cas;

struct Objet
	{
	long	ofmain;	/* offset vers bloc bitmap	*/
	long	ofeven;	/* offset vers bloc cases logiques	*/
	long	ofwork;	/* offset vers bloc travail	*/
	struct Objet *nextp;	/* prochain objet dans la pile bureau	*/
	struct Objet *prevp;	/* objet prcdent dans la pile bureau	*/
	struct Objet *pere;	/* objet pre : les coordonnes de l'objet lui sont relatives
				NULL si pas de pre (cas gnral)	*/ 
	int	nwork;	/* nombre de work dfinis	*/
	struct Fen	fen;	/* fentre de rafrachissement des modifications */
	int	workcurs;	/* work du curseur courant	*/
	int	proc;	/* ID du processus pre		*/
	int	sproc;	/* ID du sous-processus pre	*/
	struct Objet *next;	/* prochain objet dans la liste des objets dclars	*/
	struct Objet *prev;	/* prcdent objet dans la liste des objets dclars	*/
	void	(*r[])();	/* ventuels registres utilisateurs	*/
	};
typedef struct Objet	*objet;

struct Mainp
	{
	int	typo;	/* type de bitmap :	b15=1 : sprite (sinon fentre)
					b14=1 : afficher en blanc sur noir
						(si fentre)
					b12 et 13 : rserv (gestion mmoire)*/
	long	adbo;	/* adresse du buffer contenant le bitmap	*/
	int	largoo;	/* longueur en octets d'une ligne du bitmap de l'objet */
	int	largo;	/* largeur-1 de l'objet, en points */
	int	hauto;	/* hauteur-1 de l'objet, en points */
	int	xoe;	/* coordonnes de l'objet par rapport au pre ou par rapport */
	int	yoe;	/* au bureau s'il n'y a pas de pre */
	int	deltax;	/* coordonnes du point de l'objet correspondant  */
	int	deltay;	/* celles de la souris */
	};
typedef struct Mainp	*mainp;

struct Event
	{
	int	ncase;	/* nombre de cases logiques dj dfinies */
	struct Case	c[];	/* zone de stockage des caractristiques des cases */
	};
typedef struct Event	*event;

struct Work
	{
	int	xwmn;
	int	ywmn;	/* coordonnes du work	*/
	int	xwmx;
	int	ywmx;
	int	xpen;	/* dernire position du crayon */
	int	ypen;
	int	xcur;	/* position du curseur	*/
	int	ycur;
	font	fonte;	/* adresse de la fonte	*/
	int	scroll;	/* variable scrolling : -1 quand scrolling vers le haut
					+1 quand scrolling vers le bas	*/
	int	inv;	/* 	b0=1 : 'print' en inverse video
				b1=1 : curseur actuellement affich
				b2=1 : curseur  laisser affich lorsqu'inactif
				b3=1 : curseur  faire clignoter	*/
	};
typedef struct Work	*work;

struct Mous			/* structure Mouse utilise pour certaines comm */
	{
	struct Objet *ob;	/* objet dans lequel on entre, d'o on sort, o l'on clique
				o l'on n-clique, ou bien o l'on lche le bouton*/
	struct Case	 *ca;	/* case dans laquelle ....(idem)...*/
	int	dx;	/* coordonnes du point par rapport  la case o l'on clique */
	int	dy;	/* ou bien o l'on lche le bouton */
			/* pour le n-click, dx contient le nombre de click	*/
	};
typedef struct Mous	Mouse;

struct File
	{		/* structure File utilise pour certaines comm */
	int	nop;	/* (inutile pour l'utilisateur)	*/
	FILE	*f;
	char	*chn;
	char	*typ;
	char	c;
	long	pos;
	long	size;
	int	err;
	};
typedef struct File	File;

struct Dat	{		/* structure Dat utilise pour les comm de type CData	*/
	void	*p;
	long	l;
	};
struct Comm
	{
	long	type;	/* type de la comm	*/
	struct Comm	*next;	/* prochaine comm dans la liste de rception	*/
	int	np;	/* ID du processus expditeur	*/
	int	nsp;	/* ID du sous-processus expditeur	*/
	union 	{		/* contenu de la comm, selon le type */
		int	i;
		long	l;
		void	*q;
		Mouse	m;
		Point	p;
		File	f;
		struct Dat	d;
		} data;
	};
typedef struct Comm	Comm;
typedef struct Comm	*comm;

struct SProcess
	{
	int	typ;	/* type : vaut toujours 1	*/
	int	fls;	/* tat : 1:normal / 2:attente / -1:suspendu	*/
	int	prs;	/* niveau de priorit	*/
	int	kprios;	/* registre utilis par le scheduler */
	long	spp;	/* pointeur de pile systme	*/
	comm	chncomm;	/* dbut de la liste de rception	*/
	comm	endcomm;	/* fin de la liste de rception	*/
	long	maskcomm;	/* masque de rception	*/
	void	*param;	/* pointeur vers les paramtres	*/
	int	flclock;	/* flag de minuterie	*/
	int	clockn;	/* compteur pour la minuterie	*/
	int	pere;	/* ID du processus pre	*/
	int	next,prev;	/* prochain et prcdent sous-processus dans la liste des frres*/
	};
typedef struct SProcess *sproc;

struct Process
	{
	int	typ;	/* type : vaut toujours 0	*/
	char	name[16];	/* nom du processus (15 lettres maxi)	*/
	int	fl;	/* tat : 1:normal / 2:attente / -1:suspendu	*/
	int	pr;	/* niveau de priorit	*/
	int	tbcomm[32];	/* table de communication par dfaut du process */
	int	kprio;	/* registre utilis par le scheduler */
	int	totals;	/* registre utilis par le scheduler */
	int	calcs;	/* registre utilis par le scheduler */
	int	comptsp;	/* dernier sous-processus excut	*/
	int	spro; 	/* premier sous-processus de la liste des fils	*/
	int	next,prev;	/* prochain et prcdent processus dans la liste des processus */
	};
typedef struct Process *proc;

struct Mem	{		/* structure des caractristiques d'un bloc mmoire	*/
	void	*deb;	/* dbut du bloc	*/
	void	*end;	/* fin du bloc	*/
	int	np;	/* processus propritaire du bloc	*/
	struct Mem	*next;	/* pointeur vers le prochain bloc de la liste	*/
	};
typedef struct Mem *mem;

struct Systeme
	{
	long	ofmains;	/* offset d'un bloc bitmap comprenant les 
			caractristiques de l'cran */
	int	nbop;	/* nombre d'objets dans la pile bureau	*/
	objet	debpile;	/* premier objet de la pile bureau	*/
	int	*maskf;	/* pointeur vers le motif de fond du bureau (16 x 16 points) */
	long	adbufwnd;	/* buffer de rafrachissement de l'cran	*/
	font	fontesys;	/* adresse de la fonte standard	*/
	int	xml;	/* position courante de la souris	*/
	int	yml;
	int	btl;	/* tat courant du bouton de la souris (1 si appuy, 0 sinon) */
	objet	obml;	/* objet considr comme tant la souris	*/
	objet	obmouse;	/* nouvel objet  considrer comme tant la souris	*/
	objet	obcsr;	/* objet dont le curseur est actif	*/
	int	duree;	/* demi-priode de clignotement	*/
	int	comptc;	/* registre utilis pour le clignotement	*/
	objet	objv;	/* objet point par la souris	*/
	cas	casv;	/* case pointe par la souris	*/
	int	state;	/* tat du systme
			b0=0 : gestion des zones dsactive
			b1=0 : gestion du bouton desactive
			b2=0 : gestion du clavier dsactive
			b3=0 : gestion du dplacement de la souris dsactiv
			b4=1 : le premier objet de la pile bureau est le seul activable
			b5=1 : souris actuellement affiche
			b15=1 : demande de retour au systme standard du Mac	*/
	void	(*always)();/* routine facultative de l'utilisateur, excute  la fin du
			gestionnaire d'vnements	*/
	objet	oblc;	/* dernier objet 'cliqu'	*/
	cas	calc;	/* dernire case 'clique	*/
	objet	obms;	/* registre tampon pour le dplacement de la souris	*/
	int	typlc;	/* type du dernier objet cliqu	*/
	int	flzone;	/* flag de demande de recalcul de objv et casv	*/
	objet	listob;	/* dbut de la liste des objets dclars	*/
	int	clknid;	
	int	clkn;	/* 4 entiers pour la gestion du n-click	*/
	int	clkc;
	int	clktime;	
	long	adec;	/* adresse de l'cran	*/
	short	voffs;	/* offset pour passer d'une ligne de l'cran  l'autre */
	int	nbln,nbcl;	/* nombre de lignes, nombre de colonnes de l'cran	*/
	int	sizw;	/* =sizeof(struct Work)	*/
	mem	first;	/* dbut de la liste des blocs mmoire */
	long	sizemem;	/* =sizeof(struct Mem)	*/
	proc	*pid;	/* table des ID	*/
	sproc	*sid;	/* idem	*/
	int	pntid;	/* pointeur de distribution d'ID	*/
	int	pro;	/* ID du dbut de la liste des processus	*/
	int	psys;	/* ID du processus systme	*/
	int	spsys;	/* ID du sous-processus fantme	*/
	int	total,calcu;	/* variables utilises par le scheduler	*/
	int	tbcomm[32];	/* table de communication par dfaut du sytme	*/
	comm	bcomm;	/* dbut de la liste des case comm disponibles	*/
	comm	firstcomm;	/* pointeur sur la liste des case comm disponibles */
	int	filep[nmaxfil];	/* table des canaux	*/
	FILE	*(Fl[nmaxfil]);
	};
typedef struct Systeme	*systeme;

extern systeme	sys;	/* pointeur sur les variables systme
			exemple : sys->state, sys->xml, ..etc	*/


/*----- DEFINITION DES VARIABLES UTILISEES
  ----- PAR LES ROUTINES EN ASSEMBLEUR ---------*/
  
/*<<<<<  VARIABLES ETENDUES >>>>>*/
#define ADINT	0X80
#define FLINTB	0X84
#define FLINT	0X86
#define SPBUF	0X88
#define SAVEA5	0X8C
#define SPMASTER	0X90
#define SPROCESS	0X94
#define PROCESS	0X96

/*<<<<<  VARIABLES SS-PROCESSUS >>>>>*/
#define SPP	8

/*<<<<<  VARIABLES SYSTEME  >>>>>*/
#define OFMAINS	0
#define NBOP	4
#define DEBPILE	6
#define MASKF	10
#define ADBUFWND	14
#define FONTESYS	18
#define OBMOUSE	32
#define STATE	52

/* VARIABLES OBJETS */
#define OFMAIN	0
#define OFEVEN	4
#define OFWORK	8
#define NEXTP	12
#define PREVP	16
#define PERE	20

/* VARIABLES MAIN */
#define TYPO	0
#define ADBO	2
#define LARGOO	6
#define LARGO	8
#define HAUTO	10
#define XOE	12
#define YOE	14

/* VARIABLES EVENT */
#define NCASE	0
#define TBCASE	2
#define SIZEC	0
#define TYPC	2
#define XCMN	4
#define YCMN	6
#define XCMX	8
#define YCMX	10

/* VARIABLES WORK */
#define XWMN	0
#define YWMN	2
#define XWMX	4
#define YWMX	6
#define XPEN	8
#define YPEN	10
#define XCUR	12
#define YCUR	14
#define FONTE	16
#define INV	22

/*<<<<<	ROUTINE DE COMPATIBLITE AVEC LE SYSTEME DU MAC	*/

extern long		adec;
extern short	voffs;
extern int		nbln,nbcl;
extern void		*bufsc;

void inimouse();

/* sauvegarde de l'cran dans le buffer a	*/
void getscreen(
	void	*a);

/* transfert du buffer a vers l'cran	*/
void putscreen(
	void	*a);
	
/* routine INKEY$	*/
int inkey();

/* initialisation graphique :
	saisit de l'adresse et des dimensions de l'cran
	dtermine l'origine de la souris
	sauvegarde l'cran	*/void inigraflib();

/* restaure l'cran et la souris	*/
void endgraflib();

extern long vrnd;

/* variable alatoire : retourne un entier compris entre 0 et 255	*/
int rnd();

/*<<<<<	ACCES AUX STRUCTURES	*/

/* retourne l'adresse du bloc dessin de l'objet obj	*/
mainp calcmainp(
	objet	obj);

/* retourne l'adresse du 'work' 0 de l'objet obj	*/
work calcwork(
	objet	obj);

/* retourne l'adresse du 'work' n de l'objet obj	*/
work calcworkn(
	objet	obj,
	int	n);

/* retourne l'adresse du bloc 'cases' de l'objet obj	*/
event calceven(
	objet	obj);

/* donne l'adresse de la prochaine case  dfinir	*/
cas newcase(
	objet	ob);

/* retourne les coordonnes cran (x,y) de l'objet ob	*/
void calcxy(
	objet	ob,
	int	*x,
	int	*y);


/*<<<<<	'RAFRAICHISSEMENT' DE L'ECRAN	*/

/* initialise une fentre de rafrachissement	*/
void clearfenclc(
	fen	f);

/* agrandit la fentre f pour qu'elle contienne la fentre g	*/
void ajfenclc(
	fen	g,
	fen	f);

extern struct Fen	fn[8];

/* initialisation de la gestion de l'cran	*/
void inifn();

/* demande le rafrachissement de la zone f  la prochaine interruption
	ne pas utiliser directement dans une application	*/
void affzone(
	fen	f);

/* rafrachit l'cran : utilis exclusivement pendant l'interruption	*/
void affn();

/* demande le rafrachissement de tout l'cran  la prochaine interruption	*/
void affscreen();

/* demande le rafrachissement de l'objet ob  la prochaine interruption	*/
void affobjet(
	objet	ob);

/* demande le rafrachissement de la fentre f  la prochaine interruption	*/
void affenclc(
	fen	f);

/* demande l'affichage des dernires modifications de l'objet ob lors de la prochaine interruption */
void afworkmodif(
	objet	ob);

/* agrandit la fentre f pour qu'elle contienne l'objet ob	*/
void ajobjclc(
	objet	ob,
	fen	f);


/*<<<<<	GESTION DES OBJETS	*/

/* demande de la mmoire pour y stocker le bitmap de l'objet ob
	(usage personnel dconseill, sauf pour crer un second buffer bitmap
	du mme objet)	*/
long askmemwind(
	objet	obj);

/* libre la mmoire bitmap de l'objet obj (usage personnel fortement dconseill)	*/
void freememwind(
	objet	obj);

/* empile l'objet ob sur le bureau,  la n-ime place	*/
void empile(
	objet	ob,
	int	n);

/* dpile l'objet ob du bureau et retourne sa position	*/
int depile(
	objet	ob);

/* retourne l'adresse de l'objet qui se trouve  la n-ime position	*/
objet readpile(
	int	n);

/* retourne la position de l'objet ob dans la pile du bureau	*/
int placepile(
	objet	ob);

/* dtruit l'objet ob	*/
void killob(
	objet	ob);

/*	routine d'initialisation d'un objet sans masque
	(usage fortement dconseill)	*/
void initw(
	objet	obj);

/* cration d'un objet de type 'fentre'
	largeur larg, hauteur haut, coordonnes (xi,yi), bf registres 'tout usage',
	nw 'work', nc 'cases'
	xi=0x8000 => coordonnes alatoires	*/
objet newwind(
	int	larg,
	int	haut,
	int	xi,
	int	yi,
	int	bf,
	int	nw,
	int	nc);

/* rinitialise un objet de type fentre :
	bitmap rinitialis
	cases logiques effaces		*/
void clearwind(
	objet	ob);

/* cration d'un objet de type 'sprite'
	largeur larg, hauteur haut, coordonnes (xi,yi), bf registres 'tout usage',
	buff pointe sur le bitmap du sprite		*/
objet newsprite(
	int	larg,
	int	haut,
	int	xi,
	int	yi,
	int	bf,
	long	buff);

/* dplace l'objet ob en (x,y) en assurant le rafrachissement de l'cran	*/
void deplaceob(
	objet	ob,
	int	x,
	int	y);

/* donne  l'objet ob de type fentre les dimensions dx,dy	*/
int agranditwind(
	objet	ob,
	int	dx,
	int	dy);

/*<<<<<	ROUTINES GRAPHIQUES	*/

/* affiche le point (x,y) du work (ob,n) en 'couleur' c :
	c=0 : fond / c=1 : forme / c=2 : eor	*/
void pset(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	c);

/* retourne l'tat du point (x,y) de l'objet ob :
	0 : fond / 1 : forme / -1 : point en dehors de la fentre	*/
int point(
	objet	ob,
	int	x,
	int	y);

/* trace la ligne (x,y)-(xs,ys) dans le work (ob,n) en 'couleur' c :
	c=0 : fond		c=1 : forme		c=2 : eor	
	(valable mme lorsque la ligne dpasse de la fentre)	*/
void line(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	xs,
	int	ys,
	int	c);

/* trace une ligne depuis la position courante du crayon jusqu'en (x,y)
	dans le work (ob,n) en couleur c	*/
void lineto(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	c);

/* trace un vecteur (dx,dy)  partir de la position courante du crayon
	dans le work (ob,n) en couleur c	*/
void linedel(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	c);

/* trace le cadre (x,y)-(xx,yy) dans le work (ob,n) en couleur c	*/
void box(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	xx,
	int	yy,
	int	c);

/* affiche le caractre ch dans le work (ob,n) en (x,y) (coordonnes bitmap du
	coin suprieur gauche)
	c=0 : normal / c<>0 : inverse video		
	( viter lorsque le curseur est apparent)	*/
void psetc(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	ch,
	int	c);

/* affiche en eor le curseur du work (ob,n)
	(usage dconseill lorsque le curseur est actif (c--d clignote))	*/
void afcurs(
	objet	ob,
	int	n);

/* dsactive le curseur courant :
	arrte le clignotement
	affiche le curseur si bit 1 de work->inv vaut 1
	efface le curseur si bit 1 de work->inv vaut 0		*/
void effcurseur();

/* efface le work (ob,n)
	(usage dconseill si le curseur apparat : utiliser plutt le code ASCII 12)	*/
void cls(
	objet	ob,
	int	n);

/* inverse le bitmap de la case c de l'objet ob	*/
void notcase(
	objet	ob,
	cas	c);


/*<<<<<	AFFICHAGE DE CARACTERES	*/

/* afficher le caractre ch dans le work (ob,n)	*/
void print(
	objet	ob,
	int	n,
	int	ch);

/* afficher la chane de caractres chn dans le work (ob,n)	*/
void printchn(
	objet	ob,
	int	n,
	char	*chn);

/* afficher la chane de caractres chn dans le work (ob,n)	puis passer  la ligne*/
void println(
	objet	ob,
	int	n,
	char	*chn);

/* afficher la valeur de l'entier n dans le work (ob,nw) en hexadcimal	*/
void printhexint(
	objet	ob,
	int	nw,
	int	n);

/* afficher la valeur de l'entier long n dans le work (ob,nw) en hexadcimal	*/
void printhexlong(
	objet	ob,
	int	nw,
	long	n);

/* placer le curseur du work (ob,n) en (x,y) (coordonnes curseur et non bitmap :
	(0,0) correspond au caractre plac en haut  gauche dans le work (ob,n)	*/
void locate(
	objet	ob,
	int	n,
	int	x,
	int	y);

/* redfinir les coordonnes du work (ob,n) comme tant (xn,yn)-(xx,yx)
	le curseur est replac  l'origine	*/
void console(
	objet	ob,
	int	n,
	int	xn,
	int	yn,
	int	xx,
	int	yx);

/* retourne la longueur de la chane chn	*/
int len(
	char	*chn);

/* modifie le dessin du n-ime caractre de la fonte 'fonte'
	ch pointe sur un tableau char[] contenant le nouveau dessin
	(fonction DEFGR$)	*/
void defgr(
	font	fonte,
	int	n,
	char	*ch);
	

/* cre le sprite standard de la souris	*/
objet inicsrstand();

/*-----	ROUTINES MULTITACHES	*/


/*<<<<<	GESTION DE LA MEMOIRE	*/

/* initialisation de la gestion mmoire	*/
void *Inimem();

/* demande un bloc mmoire de longueur l
	retourne NULL si impossible	*/
void *Malloc(
	long	l);

/* libre le bloc b	*/
int Free(
	void	*b);

/* retourne le n-ime bloc mmoire de la liste des allocations	*/
mem memn(
	int	n);

/* retourne la taille du plus grand bloc encore allouable	*/ 
long Maxmem();

/* retourne la taille maximale que l'on peut donner au bloc b
long Maxagrandmem(
	void	*b);

/* agrandit le bloc b  la taille l (avec changement ventuel de l'adresse du bloc).
	ne change rien et retourne NULL si impossible	*/
void *Agrandmem(
	void	*b,
	long	l);


/*<<<<<	ROUTINES DE COMMUNICATION INTER-PROCESS	*/

/* initialise la gestion des communications	*/
void IniComm();

/* demande un nouveau bloc de communication */
comm GetcaseComm();

/* rend un bloc de communication */
void BackcaseComm(
	comm	c);

/* lit une comm dans la file d'attente du sous-process en cours
	avec le masque msk
	(aprs traitement, il faudra 'rendre' la comm par BackcaseComm() )	*/
comm ReadComm(
	long	msk);

/* envoie la comm c vers le destinataire n :
	n=Defaut	: lit le process destinataire dans la table de comm par dfaut : tbcomm[]
	n=ID de processus : lit le sous-processus destinataire dans la table de comm par dfaut
			du processus n
	n=ID de sous-processus : envoye la comm, si le masque le permet
	n=Nid : communication avorte
	retourne l'ID du destinataire si succs, Nid si chec	*/
int SendComm(
	comm	c,
	int	nsp);

/* modifie le masque de rception du sous-processus courant	*/
void SetMaskComm(
	long	msk);

/* lit le masque de rception du sous-processus courant	*/
long GetMaskComm();

/* positionne la table des comm par dfaut du systme pour que le processus courant
	reoive les comm de type i	*/
void ReceiveP(
	long	i);

/* positionne la table des comm par dfaut du processus courant pour que le sous-processus courant
	reoive les comm de type i	*/
void ReceiveSP(
	long	i);

/* lit une comm dans la liste de rception (avec masque m) et la copie dans c
	(c est une variable de l'utilisateur)	*/
int GetComm(
	comm	c,
	long	m);
	
/* envoyer un entier i vers nsp	*/
int SendInt(
	int	i,
	int	nsp);

/* lire un entier dans la liste de rception
	retourne 0x8000 si aucune comm de type CInt dans la liste	*/
int GetInt();

/* envoyer un code erreur i vers nsp	*/
int SendError(
	int	i,
	int	nsp);

/* lire un code erreur dans la liste de rception
	retourne 0 si aucune comm de type CError dans la liste	*/
int GetError();

/* envoyer un caractre i vers nsp	*/
int SendChar(
	int	i,
	int	nsp);

/* lire un caractre dans la liste de rception
	retourne 0x8000 si aucune comm de type CChar dans la liste	*/
int GetChar();

/* envoyer une valeur d'horloge i vers nsp	*/
int SendClock(
	int	i,
	int	nsp);

/* lire une valeur d'horloge dans la liste de rception
	retourne 0x8000 si aucune comm de type CClock dans la liste	*/
int GetClock();

/* envoyer un entier long l vers nsp	*/
int SendLong(
	long	l,
	int	nsp);

/* lire un entier long dans la liste de rception
	retourne 0x80000000 si aucune comm de type CLong dans la liste	*/
long GetLong();

/* envoyer un pointeur p vers nsp	*/
int SendPoint(
	void	*p,
	int	nsp);

/* lire un pointeur dans la liste de rception
	retourne NULL si aucune comm de type CPnt dans la liste	*/
void *GetPoint();

/* envoyer un bloc fichier f vers nsp
	(ne pas utiliser directement : passer par les fonctions volues - fichier utildesk) */
int SendFile(
	File	*f,
	int	nsp);

/* lire un bloc f dans la liste de rception
	retourne NULL si aucune comm de type CFile dans la liste
	(ne pas utiliser)	*/
int GetFile(
	File	*f);

/* envoyer un bloc Mouse vers nsp
	(ne pas utiliser : appeler les routines qui suivent)	*/
int SendM(
	objet	objv,
	cas	casv,
	int	i,
	int	dx,
	int	dy,
	int	nsp);

/* envoyer une comm 'entre de zone' vers nsp
	(la souris vient d'entrer dans la case casv de l'objet objv)	*/
int SendEnter(
	objet	objv,
	cas	casv,
	int	nsp);

/* envoyer une comm 'sortie de zone' vers nsp
	(la souris vient de quitter la case casv de l'objet objv)	*/
int SendQuit(
	objet	objv,
	cas	casv,
	int	nsp);

/* envoyer une comm 'Click' vers nsp
	(click de la souris sur le point (dx,dy) de la case casv de l'objet objv)	*/
int SendClick(
	objet	objv,
	cas	casv,
	int	dx,
	int	dy,
	int	nsp);

/* envoyer une comm 'Fin de Click' vers nsp
	(fin click de la souris sur le point (dx,dy) de la case casv de l'objet objv)	*/
int SendClickE(
	objet	objv,
	cas	casv,
	int	dx,
	int	dy,
	int	nsp);

/* envoyer une comm 'n-ime Click' vers nsp
	(n-ime click de la souris sur la case casv de l'objet objv)	*/
int SendClickn(
	objet	objv,
	cas	casv,
	int	n,
	int	nsp);

/* lire un bloc Mouse dans la liste de rception et le recopier dans m (variable utilisateur)
	(ne pas utiliser : appeler les routines qui suivent)	*/
int GetM(
	long	i,
	Mouse	*m);

/* lire un bloc mouse de type 'entre de zone'	*/
int GetEnter(
	Mouse	*m);

/* lire un bloc mouse de type 'sorite de zone'	*/
int GetQuit(
	Mouse	*m);

/* lire un bloc mouse de type 'click'	*/
int GetClick(
	Mouse	*m);

/* lire un bloc mouse de type 'fin de click'	*/
int GetClickE(
	Mouse	*m);

/* lire un bloc mouse de type 'n-ime click'	*/
int GetClickn(
	Mouse	*m);

/* envoye un couple d'entiers (x,y) vers nsp	*/
int SendMove(
	int	x,
	int	y,
	int	nsp);
	
/* lire un couple d'entiers dans la liste de rception
	retourne -1 si aucune comm de type CMove dans la liste	*/
int GetMove(
	Point	*p);

/* envoye le contenu du buffer p de longueur l vers nsp	*/
int SendData(
	void	*p,
	long	l,
	int	nsp);

/* rceptionne un buffer depuis la liste de rception (longueur l)
	retourne NULL si aucune comm de type CMove dans la liste
	ce buffer a t cr par un Malloc, et le bloc mmoire est 
		au nom du processus receveur : ne pas oublier un Free() aprs traitement */
void *GetData(
	long	*l);

/*<<<<<	ROUTINES PROCESSUS	*/

/* initialise la gestion des processus	*/
void iniprocess();

/* Cre un nouveau sous-processus frre
	p : adresse de la routine  excuter
	level : niveau de priorit
	n : taille de la pile systme
	pnt : pointeur vers un bloc de paramtres que l'on passe au sous-processus	*/
int CreateSProcess(
	void	(*p)(),
	int	level,
	long	n,
	void	*pnt);

/* Cre un nouveau process
	name : nom (15 lettres maxi)
	lev : niveau de priorit du processus
	p, level, n, pnt : caractristiques du premier sous-processus de ce nouveau processus */
int CreateProcess(
	char	*name,
	int	lev,
	void	(*p)(),
	int	level,
	long	n,
	void	*pnt);

/* dtermine si l'ID nsp est encore valide
	1:oui / 0:non	*/
int present(
	int	nsp);

/* dtruit le sous-process nsp
	et dtruit le processus pre s'il ne reste plus de sous-processus
	( utiliser pour dtruire un AUTRE sous-processus : pour se dtruire soi-mme,
	utiliser EndSProcess() )	*/
int KillSProcess(
	int	nsp);

/* dtruit le processus np
	( utiliser pour dtruire un AUTRE processus : pour se dtruire soi-mme,
	utiliser EndProcess() )	*/
int KillProcess(
	int	np);

/* suspend le sous-processus nsp
	(qui ne doit pas tre le sous-processus en cours)	*/
void SuspendSProcess(
	int	nsp);

/* suspend le processus np
	(qui ne doit pas tre le processus en cours)	*/
void SuspendProcess(
	int	np);

/* place le sous-processus courant en attente d'une comm de type compatible avec le masque msk
	retourne le type de la premire comm en accord avec le masque	*/
long WaitforComm(
	long	msk);

/* fin d'un sous-processus : le sous-processus se dtruit */
void EndSProcess();

/* fin d'un processus : le processus se dtruit */
void EndProcess();

/* donne la priorit level au sous-process nsp	*/
void LevelSProcess(
	int	nsp,
	int	level);

/* donne la priorit level au process np	*/
void LevelProcess(
	int	np,
	int	level);

/* continue le droulement du sous-process nsp
	(si celui-ci avait t suspendu)	*/
void ContinueSProcess(
	int	nsp);

/* continue le droulement du process np
	(si celui-ci avait t suspendu)	*/
void ContinueProcess(
	int	np);

/* lit le pointeur vers le bloc de paramtres du sous-processus
	(pointeur pass par CreateSProcess)	*/
void *GetParam();

/* retourne l'ID du n-ime processus */
int procn(
	int	n);

/* retourne l'ID du n-ime sous-processus */
int sprocn(
	int	n,
	int	p);

/* rgle la minuterie du sous-processus pour qu'une comm 'horloge' soit reue n cycles plus tard */
void OnceRing(
	int	n);
	
/* rgle la minuterie du sous-processus pour qu'une comm 'horloge' soit reue tous les n cycles */
void AlwaysRing(
	int	n);

/*-----	ROUTINES DE GESTION D'EVENEMENTS	*/

/* dtermine  quel objet obp et  quelle case cp appartient le point (x,y) de l'cran
	retourne aussi (dxp,dyp) coordonnes de (x,y) dans la case cp	*/
void objetvise(
	objet	*obp,
	cas	*cp,
	int	*dxp,
	int	*dyp,
	int	x,
	int	y);

/* rend actif le curseur du work(ob,n)
	(et donc dsactive l'ancien curseur)	*/
void chgcurseur(
	objet	ob,
	int	n);

/* point d'entre du systme :
	installe tout
	lance le processus systme
	lance un processus utilisateur (name,pr)
	et un premier sous-processus (proce,prs,n,pnt)		*/
int desk(
	char	*name,
	int	pr,
	void	(*proc)(),
	int	prs,
	long	n,
	void	*pnt);

/*-----	ROUTINES D'UTILISATION STANDARD	*/

/*<<<<<	DEFINITION DE CASE	*/ 
/* dfinit une nouvelle case rectangulaire dans l'objet ob,
	(x,y)-(xx,yy) : coordonnes de la case
	typ	: si bit1=1, trace un cadre autour de la case (dans le work n)
	siz	: nombre de registres utilisateurs
	typc	: type de la case
	clk	: ID sous-processus pour rception du click
	zone	: ID sous-processus pour rception de 'entre de zone'	*/
cas newcvide(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	xx,
	int	yy,
	int	typ,
	int	siz,
	int	typc,
	int	clk,
	int	zone);

/* dfinit une nouvelle case rectangulaire dans l'objet ob, avec un texte dedans
	chn	: chane de caractres  afficher dans la case (utilisation du work n)
	(x,y)	: position de la case
	typ	: si bit1=1, trace un cadre autour de la case (dans le work n)
	siz	: nombre de registres utilisateurs
	typc	: type de la case
	clk	: ID sous-processus pour rception du click
	zone	: ID sous-processus pour rception de 'entre de zone'	*/
cas newc(
	objet	ob,
	int	n,
	char	*chn,
	int	x,
	int	y,
	int	typ,
	int	siz,
	int	typc,
	int	clk,
	int	zone);

/* dfinition rapide d'une barre de menu pour l'objet ob :
	name : nom de la fentre
	endsp: ID d'un sous-processus pour recevoir le click sur la case 'destruction'
		la fonction retourne alors l'adresse de cette case
	      si =Nid, pas de case destruction
  cre aussi une grande case 'dplacement devant' (taille de la fentre)
  	et une autre 'dplacement derrire'		*/
cas setbarre(
	objet	ob,
	char	*name,
	int	endsp);

/* habillage standard de l'objet ob :
	barre de menu (et de 'dplacement devant')
	case de 'dplacement derrire'
	case de destruction
	ascenseurs vertical et horizontal
	case d'agrandissement
	case de travail pour 'inputchn()' : ce qui reste de la fentre
   paramtres :
	name : nom de la fentre
	endc : adresse d'un pointeur pour y stocker l'adresse de la case destruction
		(NULL => pas de case destruction)
	vert : pointeur vers l'entier qui contiendra la position de l'ascenseur vertical
		(NULL => pas d'ascenseur vertical)
	vertmax : pointeur vers l'entier qui contiendra la position maximale +1 de l'ascenseur
	hori : pointeur vers l'entier qui contiendra la position de l'ascenseur horizontal
		(NULL => pas d'ascenseur horizontal)
	horimax : pointeur vers l'entier qui contiendra la position maximale +1 de l'ascenseur
	typ : type des ascenseurs
	agrandc : adresse d'un pointeur pour y stocker l'adresse de la case agrandissement
		(NULL => pas de case agrandissement)
	fentravail : adresse d'un pointeur pour y stocker l'adresse de la case travail
		(NULL => pas de case travail)
   pour pouvoir utiliser les ascenseurs, il faut avoir dfini au moins 2 'work'	*/
void standard(
	objet	ob,
	char	*name,
	cas	*endc,
	int	*vert,
	int	*vertmax,
	int	*hori,
	int	*horimax,
	int	typ,
	cas	*agrandc,
	cas	*fentravail);

/*<<<<<	CHOIX / MENU DEROULANT / CONFIRMATION	*/
/* gestion d'un menu droulant
	lg : largeur en caractres du menu
	n : nombre de lignes
	last : numro du dernier choix (0 si aucun)
	fonte : fonte  utiliser (NULL => fonte systme)
	puis les diffrents choix (chanes de caractre)
   retourne le numro du choix (0 si pas de choix)
   attention !! : certaines comm en attente dans la liste de rception peuvent disparatre */
int choix(
	int	lg,
	int	n,
	int	last,
	font	fonte,
	char	*ch,
	 ...);

/* gestion d'un menu droulant appos sous la case c de l'objet ob
	lg : largeur en caractres du menu
	n : nombre de lignes
	last : numro du dernier choix (0 si aucun)
	fonte : fonte  utiliser (NULL => fonte systme)
	puis les diffrents choix (chanes de caractre)
   retourne le numro du choix (0 si pas de choix)
   attention !! : certaines comm en attente dans la liste de rception peuvent disparatre */
int menuder(
	objet	obc,
	cas	c,
	int	lg,
	int	n,
	int	last,
	font	fonte,
	char	*ch,
	 ...);
	
/* gestion d'une fentre de confirmation :
	chn : texte  afficher dans la fentre
	annule = 0 : cases 'oui' et 'non'
	       > 0 : cases 'oui', 'non' et 'ignorer'
	       < 0 : case 'ok'
   retourne	1 : oui
	0 : non
	-1: ignorer ou ok
	-2: pas assez de mmoire pour ouvrir la fentre de confirmation	*/
int confirmation(
	char	*chn,
	int	annule);

/*<<<<<	INTERFACE CLAVIER	*/
/* dfinit une case pour utiliser ensuite inputchn()
	si xn<0, ignore yn,xx,yx et cre une case aux dimensions du work (ob,n)
	si xn>=0 donne au work (ob,n) les nouvelles coordonnes (xn,yn)-(xx,yx) et cre
		une case  ces dimensions
	la case est cre avec le type typ		*/
cas DefCasInput(
	objet	ob,
	int	n,
	int	xn,
	int	yn,
	int	xx,
	int	yx,
	int	typ);

/* saisie d'une chane de caractres dans le work (ob,n)
	cs : case dans laquelle il faut cliquer pour rendre de nouveau le curseur actif.
	chn : pointeur vers le buffer dans lequel est stock la chane
	pt : nombre de caractres pr-dfinis dans le buffer au moment de l'appel de cette routine
		(vaut normalement 0) 
	ln : taille du buffer		*/
void inputchn(
	objet	ob,
	int	n,
	cas	cs,
	char	*chn,
	int	pt,
	int	ln);

/*<<<<<	GESTION DES FICHIERS, DE TYPE ANSI	*/
/* fonction quivalente  fopen de ANSI	*/
FILE *Fopen(
	char	*chn,
	char	*typ);

/* fonction quivalente  fclose de ANSI	*/
void Fclose(
	FILE	*fil);

/* fonction quivalente  getc de ANSI	*/
char Getc(
	FILE	*fil);

/* fonction quivalente  seek de ANSI	*/
void Fseek(
	FILE	*fil,
	long	offs,
	int	orig);
	
/* fonction quivalente  fread de ANSI	*/
long Fread(
	void	*ptr,
	long	size,
	long	nmemb,
	FILE	*fil);

/* fonction quivalente  fwrite de ANSI	*/
long Fwrite(
	void	*ptr,
	long	size,
	long	nmemb,
	FILE	*fil);

/* fonction quivalente  putc de ANSI	*/
int Putc(
	int	c,
	FILE	*fil);

/*<<<<<	ASCENSEURS	*/
/* cration d'un ascenseur vertical dans le work (ob,n)
	(x,y) : coordonnes du coin suprieur gauche
		(la largeur de l'ascenseur est de 9 points)
	dy : valeur maximale +1 de l'entier li  l'ascenseur (=hauteur de l'ascenseur - 8)
	val : pointeur sur l'entier li  l'ascenseur
	typ =0 : une comm 'CPnt' est envoye lorsque l'utilisateur relche le bouton
	    <>0: une comm 'CPnt' est envoye pendant le dplacement du bouton	
	  la comm envoye contient l'adresse de la case ascenseur
	attention lors de la cration de l'objet (et dans le choix du nombre de cases)!! :
	une case ascenseur utilise 4 registres utilisateurs : 
		elle compte pour deux cases normales */
cas vertlift(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	dy,
	int	*val,
	int	typ);

/* cration d'un ascenseur horizontal dans le work (ob,n)
	(x,y) : coordonnes du coin suprieur gauche
		(la hauteur de l'ascenseur est de 9 points)
	dy : valeur maximale +1 de l'entier li  l'ascenseur (=largeur de l'ascenseur - 8)
	val : pointeur sur l'entier li  l'ascenseur
	typ =0 : une comm 'CPnt' est envoye lorsque l'utilisateur relche le curseur
	    <>0: une comm 'CPnt' est envoye pendant le dplacement du curseur
	  la comm envoye contient l'adresse de la case ascenseur
	attention lors de la cration de l'objet (et dans le choix du nombre de cases)!! :
	une case ascenseur utilise 4 registres utilisateurs : 
		elle compte pour deux cases normales */
cas horilift(
	objet	ob,
	int	n,
	int	x,
	int	y,
	int	dx,
	int	*val,
	int	typ);

/* sous-processus installant les sous-processus systme	*/
void sproc1sys();


