#include "desk.h"

/*	JULIA		*/

/*	format utilis pour les valeurs complexes :
	32 bits signs, diviss comme suit :
		- 3 bits de partie entire signe
		- 29 bits de partie 'dcimale'	
	
	l'appli ne fonctionne qu'avec au moins un 68020	*/

struct Jul		/* structure passe au sous-processus charg du calcul	*/
	{
	objet ob;	/* objet dans lequel afficher l'ensemble de Julia	*/
	long xn;	/* coordonnes (xn,yn)-(xx,yx) du dessin	*/
	long yn;
	long xx;
	long yx;
	int n;	/* nombre d'itrations choisi	*/
	long cx,cy;
	};

struct Coord
	{
	long	cx;
	long	cy;
	};

/* routine de calcul d'une suite :
	(x,y) : valeur initiale de u0
	(cx,cy) : valeur de la constante
	n : nombre d'itrations maxi
 retourne le rang de divergence	*/
int divergj(x,y,cx,cy,n)
	long x,y;
	long cx,cy;
	int n;
{
asm
	{
	movem.l	d1-d7/a0,-(sp)
	move.w	n,d7
	move.l	x,d0
	move.l	y,d1
	move.l	cx,d2
	move.l	cy,d3
	move.l	#0x10000000,a0
	
@0	move.l	d0,d5
	muls.l	d0,d4:d5	/*	calcul de x2	*/
	cmp.l	a0,d4
	bhs	@1
	lsl.l	#3,d4
	rol.l	#3,d5
	andi.w	#7,d5
	or.w	d5,d4

	move.l	d1,d6
	muls.l	d1,d5:d6	/*	calcul de y2	*/
	cmp.l	a0,d5
	bhs	@1
	lsl.l	#3,d5
	rol.l	#3,d6
	andi.w	#7,d6
	or.w	d6,d5
	
	move.l	d5,d6
	add.l	d4,d6
	bvs	@1	/*	test x2+y2>=4	*/
	
	sub.l	d5,d4	/*	calcul de x2-y2	*/
	muls.l	d1,d1:d0	/*	calcul de 2xy	*/
	lsl.l	#4,d1
	rol.l	#3,d0
	lsl.w	#1,d0
	andi.w	#15,d0
	or.w	d0,d1
	
	move.l	d4,d0
	add.l	d2,d0	/* additionne Cx	*/
	bvs	@2
	add.l	d3,d1	/* additionne Cy	*/
	bvs	@2
	dbra	d7,@0
@2	subq.w	#1,d7
@1	move.w	n,d0
	sub.w	d7,d0	/*	retourne nbiter	*/
	movem.l	(sp)+,d1-d7/a0
	}
}


/* sous-processus de calcul de l'ensemble de julia	*/
void juli()
	{
		int	i,j;
		long	x,y,dx,dy,e;
		work	p;
		int	pl,ph;
		struct Jul	*m=(struct Jul*)GetParam();
	
	p=calcwork(m->ob);
			/* dans un premier temps, recentrage de la zone de calcul
			pour garder la mme chelle sur les x et les y	*/
	pl=p->xwmx-p->xwmn; ph=p->ywmx-p->ywmn;
	dx=(m->xx-m->xn)/pl;
	dy=(m->yx-m->yn)/ph;
	if (dx>dy)	{
		e=(m->xx-m->xn-dy*pl)/2;
		m->xn+=e;
		m->xx-=e;
		}
		else
		{
		e=(m->yx-m->yn-dx*ph)/2;
		m->yn+=e;
		m->yx-=e;
		}
	dx=(m->xx-m->xn)/pl;
	dy=(m->yx-m->yn)/ph;
	y=m->yn;
			/* boucle de calcul	*/
	for (j=p->ywmn;j<=p->ywmx;j++)
		{
		x=m->xn;
		for (i=p->xwmn;i<=p->xwmx;i++)
			{
			if (diverg(x,y,m->cx,m->cy,m->n)&1) pset(m->ob,0,i,j,2);
			x+=dx;
			}
		afworkmodif(m->ob);	/* rafrachir l'cran  la fin de la ligne	*/
		y+=dy;
		}
	EndSProcess();	/* fin du calcul	*/
	}

/* initialisation de la fentre de l'application
	dfinition des diverses cases	*/
void inijulia(ob,endc,niveau,grand,dessin)
	objet	ob;
	cas	*endc,*niveau,*grand,*dessin;
	{
		work	w;
	
	w=calcwork(ob);
	standard(ob,"Julia",endc,NULL,NULL,NULL,NULL,0,grand,dessin);
	*niveau=newc(ob,1," profondeur ",1,calcmainp(ob)->hauto-w->fonte->haut
			,2,0,0,sprocess,Nid);
	}

/* point d'entre de l'application	*/
void julia()
{
	objet	ob;
	work	w;
	cas	endc,dessin,niveau,grand;
	struct Jul	m;
	struct Coord *p=(struct Coord*)GetParam();
	int	i,j;
	Mouse	mo;
	int	calc;

m.cx=p->cx;
m.cy=p->cy;
		/* dfinition de la fentre	*/
ob=newwind (300,200,0x8000,0,0,2,10);
if (ob==NULL) EndProcess();	/* pas assez de mmoire	*/
empile(ob,1);	/* empile la fentre sur le bureau	*/
inijulia(ob,&endc,&niveau,&grand,&dessin);	/* initialise la fentre	*/
affobjet(ob);	/* rafrachit l'cran : fait apparatre la fentre	*/

m.ob=ob;
m.xn=-0x40000000+1;	/* coordonnes du premier dessin	*/
m.yn=-0x28000000;
m.xx=0x40000000;
m.yx=0x28000000;
m.n=30;		/* profondeur initiale : 30	*/

while(1)
  {
  cls(ob,0);
  calc=CreateSProcess(juli,1,2048,(void*)&m);	/* lance le sous-processus charg du calcul	*/
  j=1;
  do	{
	i=WaitforComm(CClick+CClickE);
	if (i==CClickE)	{
		GetClickE(&mo);
		if (mo.ca==endc)
			EndProcess();	/* click sur la case de destruction	*/
		}
	if (i==CClick)	{
		GetClick(&mo);
		if (mo.ca==dessin)	/* click sur le dessin : procdure de zoom	*/
			{
				int	x,y,xx,yy,f,k;
				long	dx,dy;
				Point	p;
	
			x=mo.dx; y=mo.dy;
			f=0;
			ReceiveP(CMove);
			ReceiveSP(CMove); /* rceptionne les mouvements de la souris*/
			do	{
				k=WaitforComm(CMove+CClickE);
				if (k==CMove)
				  {
				  	/* dplacement de la souris :
				  	changement du cadre de zoom	*/
				  GetMove(&p);
				  if (f) box(ob,0,x+dessin->xcmn,
				  	y+dessin->ycmn,
				  	xx+dessin->xcmn,
				  	yy+dessin->ycmn,2);
				  f=0;
				  xx=p.h-calcmainp(ob)->xoe-dessin->xcmn;
				  yy=p.v-calcmainp(ob)->yoe-dessin->ycmn;
				  if ((xx>x)&&(xx+dessin->xcmn<=dessin->xcmx)
				  	&&(yy>y)&&(yy+dessin->ycmn<=dessin->ycmx))
				  	{
				  	f=1;
				  	box(ob,0,x+dessin->xcmn,
				  	y+dessin->ycmn,
				  	xx+dessin->xcmn,
				  	yy+dessin->ycmn,2);
				  	}
				  afworkmodif(ob);
				  }
				}
			while (k!=CClickE);	/* bouton relch	*/
			GetClickE(&mo);
			if (f)	{
				KillSProcess(calc);
					/* nouvelle coordonnes de calcul	*/
				dx=(m.xx-m.xn)/(dessin->xcmx-dessin->xcmn);
				dy=(m.yx-m.yn)/(dessin->ycmx-dessin->ycmn);
				m.xx=m.xn+xx*dx;
				m.yx=m.yn+yy*dy;
				m.xn+=x*dx;
				m.yn+=y*dy;
				j=0;
				}
			}
		if (mo.ca==niveau)
			{	/* choix de la profondeur de calcul	*/
				int	n;
			n=menuder(ob,niveau,
				10,10,(m.n-30)/50+1,NULL,"30","80","130","180"
				,"230","280","330","380","430","480");
			if (n>0) m.n=(n-1)*50+30;
			}
		if (mo.ca==grand)
			{
				/* procdure d'agrandissement	*/
				
				int	x,y,dx,dy,k;
				Point	q;
				mainp	p=calcmainp(ob);
				struct Fen	f;
			
			KillSProcess(calc);
			x=p->xoe; y=p->yoe;
			ReceiveP(CMove);
			ReceiveSP(CMove);
			do	{
				k=WaitforComm(CMove+CClickE);
				if (k==CMove)
				  {
				  while(GetMove(&q)==0);
				  dx=q.h-x; dy=q.v-y;
				  if (dx<160) dx=160;
				  if (dy<160) dy=160;
				  clearfenclc(&f);
				  ajobjclc(ob,&f);
				  agranditwind(ob,dx,dy); /* agrandit la fentre */
				  ajobjclc(ob,&f);
				  affenclc(&f);	/* rafrachit l'cran	*/
				  }
				}
			while (k!=CClickE);
			GetClickE(&mo);
			inijulia(ob,&endc,&niveau,&grand,&dessin);
			affobjet(ob);
			j=0;
			}
		}
	}
  while(j);
  }
}
