#include "desk.h"

/* VARIABLES ROUTINE AFFICHAGE */
#define XCW	0
#define YCW	2
#define LARGW	4
#define HAUTW	6
#define LARGOW	8
#define LARGMW	10
#define NBFEN	12
#define ADPFEN	14
#define HAUTI	18
#define MASKG	20
#define MASKD	22


systeme	sys;
long	adec;
short	voffs;
int	nbln,nbcl;
void	*bufsc;

void inimouse()
	{
		Rect	ri;
		
	SetRect(&ri,0,0,20,20);
	SetDrawingRect(&ri);
	}

/* sauvegarde de l'cran dans le buffer a	*/
void getscreen(a)
	void	*a;
	{
	asm
		{
		movem.l	d1-d2/a0-a1,-(sp)
		move.l	adec,a1
		move.l	a,a0
		move.w	nbln,d2
		subq.w	#1,d2
	@0	move.w	voffs,d1
		lsr.w	#2,d1
		subq.w	#1,d1
	@1	move.l	(a1)+,(a0)+
		dbra	d1,@1
		dbra	d2,@0
		movem.l	(sp)+,d1-d2/a0-a1
		}
	}

/* transfert du buffer a vers l'cran	*/
void putscreen(a)
	void	*a;
	{
	asm
		{
		movem.l	d1-d2/a0-a1,-(sp)
		move.l	a,a1
		move.l	adec,a0
		move.w	nbln,d2
		subq.w	#1,d2
	@0	move.w	voffs,d1
		lsr.w	#2,d1
		subq.w	#1,d1
	@1	move.l	(a1)+,(a0)+
		dbra	d1,@1
		dbra	d2,@0
		movem.l	(sp)+,d1-d2/a0-a1
		}
	}

/* routine INKEY$	*/
int inkey()
	{
	asm
		{
		lea.l	@eventr,a0
		move.w	#0x38,d0
		_GetOSEvent
		and.w	#0xff,d0
		not.b	d0
		beq	@1
		clr.w	d0
		cmp.w	#4,(a0)
		beq	@1
		move.l	2(a0),d0
		bra	@1
	@eventr
		dc.l	0,0,0,0,0,0,0,0
	@1	
		}
	}

/* variable alatoire : retourne un entier compris entre 0 et 255	*/
long vrnd;

int rnd()
	{
	asm	{
		MOVE.L	vrnd,D0
		SWAP	D0
		ROL.L	#7,D0
		EOR.L	#0X29384756,D0
		ADD.L	D0,vrnd
		AND.W	#255,D0
		}
	}

/* initialisation graphique :
	saisit de l'adresse et des dimensions de l'cran
	dtermine l'origine de la souris
	sauvegarde l'cran	*/
void inigraflib()
	{
	InitQuickDraw();
	adec=(long) screenBits.baseAddr;
	voffs=screenBits.rowBytes;
	nbln=screenBits.bounds.bottom-screenBits.bounds.top;
	nbcl=screenBits.bounds.right-screenBits.bounds.left;
	
	inimouse();
	
	HideCursor();
	bufsc=malloc(33000);
	if (bufsc!=NULL) getscreen(bufsc);
	asm
		{
		move.l	#0xffff,d0
		_FlushEvents
		}
	}

/* restaure l'cran et la souris	*/
void endgraflib()
	{
	if (bufsc!=NULL) { putscreen(bufsc);free(bufsc); }
	ShowCursor();
	asm	{
		move.l	#0xffff,d0
		_FlushEvents
		}
	}


/*	Routine graphique de base : rafrachissement d'une zone de l'cran
	pointeur sur xmin,ymin,xmax,ymax
	excute exclusivement pendant l'interruption (interdite  l'utilisateur)*/
void affzonersc(fene)
	fen	fene;
	{
	asm
		{
		MOVEM.L	D0-D7/A0-A6,-(SP)
		MOVE.L	fene,A0
		MOVE.L	sys,A6
		SUB.L	#50,A7
		MOVE.L	A7,A5
		MOVEM.W	(A0),D0-D3
		BSR	@TESTEXT
		
		AND.W	#0XFFF0,D0
		OR.W	#15,D2
		SUB.W	D0,D2
		SUB.W	D1,D3
		MOVEM.W	D0-D3,XCW(A5)
		LSR.W	#4,D2
		ADDQ.W	#1,D2
		MOVE.W	D2,LARGMW(A5)
		MOVE.L	A6,A4
		ADD.L	OFMAINS(A6),A4
		LSL.W	#1,D2
		MOVE.W	D2,LARGOW(A5)
	
		CLR.W	NBFEN(A5)
		MOVE.L	DEBPILE(A6),A0
		MOVE.W	NBOP(A6),D7
		BRA	@AFFZ1
	;	dtermine si la fentre  rafrachir est totalement incluse dans un objet
	;	(inutile alors de rafficher ce qui est derrire cet objet, en particulier
	;	le motif de fond)
	@AFFZ0
		ADDQ.W	#1,NBFEN(A5)
		MOVE.L	A0,A1
		MOVE.L	A0,ADPFEN(A5)
		MOVE.L	NEXTP(A0),A0
		TST.L	PERE(A1)
		BNE	@AFFZ1
		ADD.L	OFMAIN(A1),A1
		TST.W	TYPO(A1)
		BMI	@AFFZ1
		MOVEM.W	XOE(A1),D0-D1
		SUB.W	XCW(A5),D0
		BGT	@AFFZ1
		SUB.W	YCW(A5),D1
		BGT	@AFFZ1
		ADD.W	LARGO(A1),D0
		SUB.W	LARGW(A5),D0
		BLT	@AFFZ1
		ADD.W	HAUTO(A1),D1
		SUB.W	HAUTW(A5),D1
		BGE	@AFFZ2
	@AFFZ1
		DBRA	D7,@AFFZ0
	
		BSR	@FONDWIND
		
	@AFFZ2
		MOVE.L	ADPFEN(A5),A0
		MOVE.W	NBFEN(A5),D7
		BRA	@AFFZ4
	;	affiche les objets dans le buffer
	@AFFZ3
		MOVE.L	A0,A4
		MOVE.L	PREVP(A0),A0
		BSR	@AFFWIND
	@AFFZ4
		DBRA	D7,@AFFZ3
	
	;	transfert le buffer vers l'cran
		BSR	@TRANSW
		ADD.L	#50,A7
		MOVEM.L	(SP)+,D0-D7/A0-A6
		BRA	@FIN
	
	;	tronque la fentre dont on demande le rafrachissement
	;	 sa restriction  l'cran
	@TESTEXT	
		MOVE.L	A6,A0
		ADD.L	OFMAINS(A6),A0
		BSR	@TESTEXTR
		BSR	@TESTEXTR
		RTS
	@TESTEXTR
		TST.W	D0
		BPL	@TESTE0
		CLR.W	D0
	@TESTE0
		TST.W	D1
		BPL	@TESTE1
		CLR.W	D1
	@TESTE1
		CMP.W	LARGO(A0),D0
		BLE	@TESTE2
		MOVE.W	LARGO(A0),D0
	@TESTE2
		CMP.W	HAUTO(A0),D1
		BLE	@TESTE3
		MOVE.W	HAUTO(A0),D1
	@TESTE3
		EXG.L	D0,D2
		EXG.L	D1,D3
		RTS
	
	;	initialise le buffer avec le motif de fond du bureau
	@FONDWIND
		MOVE.L	ADBUFWND(A6),A0
		MOVE.L	MASKF(A6),A1
		MOVE.W	YCW(A5),D0
		LSL.W	#1,D0
		MOVE.W	HAUTW(A5),D7
	@FONDW0
		AND.W	#0X1F,D0
		MOVE.W	(A1,D0.W),D1
		NOT.W	D1
		
		MOVE.W	LARGMW(A5),D6
		SUBQ.W	#1,D6
	@FONDW1
		MOVE.W	D1,(A0)+
		DBRA	D6,@FONDW1
		ADDQ.W	#2,D0
		DBRA	D7,@FONDW0
		RTS
	
	@AFFWIND
		MOVEM.L	D7/A0/A4-A6,-(SP)
		BSR	@CALCPREL
		TST.L	D7
		BEQ	@AFFWF
		BSR	@DESINTER
	@AFFWF
		MOVEM.L	(SP)+,D7/A0/A4-A6
		RTS
	
	;	calcul prliminaire de l'intersection d'un objet avec le buffer	
	@CALCPREL
		CLR.L	D7
		MOVE.L	A4,A1
		ADD.L	OFMAIN(A4),A4
		MOVEM.W	XOE(A4),D0/D1
		BRA	@CPRELR1
	@CPRELR0	MOVE.L	PERE(A1),A1
		MOVE.L	A1,A0
		ADD.L	OFMAIN(A1),A0
		ADD.W	XOE(A0),D0
		ADD.W	YOE(A0),D1
	@CPRELR1	TST.L	PERE(A1)
		BNE	@CPRELR0
		MOVE.W	D0,D2
		MOVE.W	D1,D3
		ADD.W	LARGO(A4),D2
		ADD.W	HAUTO(A4),D3
		MOVEM.W	XCW(A5),D4/D5
		ADD.W	LARGW(A5),D4
		ADD.W	HAUTW(A5),D5
		
		CMP.W	D4,D0
		BGT	@CPRELF
		CMP.W	XCW(A5),D2
		BLT	@CPRELF
		CMP.W	D5,D1
		BGT	@CPRELF
		CMP.W	YCW(A5),D3
		BLT	@CPRELF
	
		MOVE.L	ADBO(A4),A0
		MOVE.L	ADBUFWND(A6),A1
		
		MOVE.W	D1,D6
		SUB.W	YCW(A5),D1
		BEQ	@CPREL1
		BGT	@CPREL0
		NEG.W	D1
		MULU	LARGOO(A4),D1
		ADD.L	D1,A0
		MOVE.W	YCW(A5),D6
		BRA	@CPREL1
	@CPREL0
		MULU	LARGOW(A5),D1
		ADD.L	D1,A1
	@CPREL1
		CMP.W	D3,D5
		BGT	@CPREL2
		MOVE.W	D5,D3
	@CPREL2
		SUB.W	D6,D3
		MOVE.W	D3,HAUTI(A5)
	
		MOVE.W	D0,D6
		AND.W	#15,D6
		MOVE.W	D0,D5
		SUB.W	XCW(A5),D0
		BEQ	@CPREL4
		BGT	@CPREL3
		NEG.W	D0
		LSR.W	#4,D0
		LSL.W	#1,D0
		TST.W	TYPO(A4)
		BPL	@CL0
		LSL.W	#1,D0
	@CL0	LEA.L	(A0,D0.W),A0
		MOVE.W	XCW(A5),D5
		BRA	@CPREL4
	@CPREL3
		LSR.W	#4,D0
		LSL.W	#1,D0
		LEA.L	(A1,D0.W),A1
		TST.W	D6
		BEQ	@CPREL4
		BSET	#31,D7
		SUBQ.W	#1,D7
	@CPREL4
		CMP.W	D2,D4
		BLE	@CPREL5
		MOVE.W	D2,D4
		AND.W	#15,D2
		CMP.W	#15,D2
		BEQ	@CPREL5
		BSET	#30,D7
		SUBQ.W	#1,D7
	@CPREL5
		LSR.W	#4,D5
		LSR.W	#4,D4
		SUB.W	D5,D4
		ADD.W	D4,D7
		ADDQ.W	#1,D7
		TST.W	D6
		BNE	@CPREL6
		SUBQ.L	#2,A0
		TST.W	TYPO(A4)
		BPL	@CPREL6
		SUBQ.L	#2,A0
	@CPREL6
		MOVE.L	#0XFFFF0000,D0
		LSR.L	D6,D0
		MOVE.W	D0,MASKG(A5)
		MOVE.L	#0X80000000,D0
		MOVE.W	LARGO(A4),D1
		AND.W	#15,D1
		ADD.W	D6,D1
		ASR.L	D1,D0
		TST.W	D0
		BNE	@CPREL7
		SWAP	D0
	@CPREL7	
		MOVE.W	D0,MASKD(A5)
		MOVE.W	LARGOO(A4),A2
		MOVE.W	LARGOW(A5),A3
		CLR.L	D4
		BTST	#6,TYPO(A4)
		BEQ	@CPRELF
		NOT.L	D4
	@CPRELF
		RTS
	
	@DESINTER
		TST.W	TYPO(A4)
		BMI	@DESIAM
		
	;	transfert des bitmap fentre vers le buffer
	;	3 boucles successives : colonnes de gauche, du milieu, et de droite
	@DESISM
		BTST	#31,D7
		BEQ	@DESISM1
		MOVEM.L	A0-A1,-(SP)
		MOVE.W	MASKG(A5),D0
		MOVE.W	D0,D3
		NOT.W	D3
		MOVE.W	HAUTI(A5),D2
	@DESISM0
		MOVE.W	(A0),D1
		LSR.W	D6,D1
		EOR.W	D4,D1
		AND.W	D3,D1
		AND.W	D0,(A1)
		OR.W	D1,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESISM0
		MOVEM.L	(SP)+,A0-A1
		ADDQ.L	#2,A1
	@DESISM1
		BRA	@DESISM4
	@DESISM2
		MOVEM.L	A0-A1,-(SP)
		MOVE.W	HAUTI(A5),D2
	@DESISM3
		MOVE.L	(A0),D0
		LSR.L	D6,D0
		EOR.W	D4,D0
		MOVE.W	D0,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESISM3
		MOVEM.L	(SP)+,A0-A1
		ADDQ.L	#2,A0
		ADDQ.L	#2,A1
	@DESISM4
		DBRA	D7,@DESISM2
		BTST	#30,D7
		BEQ	@DESISMF
		MOVE.W	HAUTI(A5),D2
		MOVE.W	MASKD(A5),D1
		MOVE.W	D1,D3
		NOT.W	D3
	@DESISM6	MOVE.L	(A0),D0
		LSR.L	D6,D0
		EOR.W	D4,D0
		AND.W	D1,D0
		AND.W	D3,(A1)
		OR.W	D0,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESISM6
	@DESISMF
		RTS
		
	;	transfert des bitmap sprite vers le buffer
	;	3 boucles successives : colonnes de gauche, du milieu, et de droite
	@DESIAM	BTST	#31,D7
		BEQ	@DESIAM1
		MOVEM.L	A0-A1,-(SP)
		MOVE.L	#0XFFFF0000,D0
		MOVE.W	HAUTI(A5),D2
	@DESIAM0
		MOVE.W	(A0),D0
		MOVE.W	2(A0),D1
		ASR.L	D6,D0
		LSR.W	D6,D1
		AND.W	D0,(A1)
		EOR.W	D1,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESIAM0
		MOVEM.L	(SP)+,A0-A1
		ADDQ.L	#2,A1
	@DESIAM1
		BRA	@DESIAM4
	@DESIAM2
		MOVEM.L	A0-A1,-(SP)
		MOVE.W	HAUTI(A5),D2
	@DESIAM3
		MOVE.L	(A0),D0
		MOVE.L	2(A0),D1
		MOVE.W	D1,D0
		MOVE.W	6(A0),D1
		LSR.L	D6,D0
		LSR.L	D6,D1
		AND.W	D0,(A1)
		EOR.W	D1,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESIAM3
		MOVEM.L	(SP)+,A0-A1
		ADDQ.L	#4,A0
		ADDQ.L	#2,A1
	@DESIAM4
		DBRA	D7,@DESIAM2
		BTST	#30,D7
		BEQ	@DESIAMF
		MOVE.W	HAUTI(A5),D2
	@DESIAM5
		MOVE.L	(A0),D0
		MOVE.W	#-1,D0
		MOVE.L	2(A0),D1
		CLR.W	D1
		LSR.L	D6,D0
		LSR.L	D6,D1
		AND.W	D0,(A1)
		EOR.W	D1,(A1)
		ADD.L	A2,A0
		ADD.L	A3,A1
		DBRA	D2,@DESIAM5
	@DESIAMF
		RTS
		
	;	transfert final du buffer vers l'cran
	@TRANSW
		MOVE.L	A6,A4
		ADD.L	OFMAINS(A6),A4
		MOVE.W	YCW(A5),D0
		MULU	LARGOO(A4),D0
		MOVE.W	XCW(A5),D1
		LSR.W	#4,D1
		LSL.W	#1,D1
		ADD.W	D1,D0
		MOVE.L	ADBO(A4),A2
		ADD.L	D0,A2
		MOVE.W	LARGOO(A4),D0
		EXT.L	D0
		MOVE.L	ADBUFWND(A6),A1
		MOVE.W	HAUTW(A5),D7
		MOVE.W	LARGMW(A5),D6
		LSL.W	#1,D6
	@TRANSW0
		MOVE.W	D6,D5
		LSR.W	#2,D5
		MOVE.L	A2,A0
		BRA	@TRANSW2
	@TRANSW1
		MOVE.L	(A1)+,(A0)+
	@TRANSW2
		DBRA	D5,@TRANSW1
		BTST	#1,D6
		BEQ	@TRANSW3
		MOVE.W	(A1)+,(A0)+
	@TRANSW3	ADD.L	D0,A2
		DBRA	D7,@TRANSW0
		RTS
	@FIN
		}
	}

/*<<<<<	ACCES AUX STRUCTURES	*/

/* retourne l'adresse du bloc dessin de l'objet obj	*/
mainp calcmainp(obj)
	objet	obj;
	{
	return (mainp) ((long) obj + (long) obj->ofmain );
	}

/* retourne l'adresse du 'work' 0 de l'objet obj	*/
work calcwork(obj)
	objet	obj;
	{
	return (work) ((long) obj + (long) obj->ofwork );
	}

/* retourne l'adresse du 'work' n de l'objet obj	*/
work calcworkn(obj,n)
	objet	obj;
	int	n;
	{
	return &calcwork(obj)[n];
	}

/* retourne l'adresse du bloc 'cases' de l'objet obj	*/
event calceven(obj)
	objet	obj;
	{
	return (event) ((long) obj + (long) obj->ofeven );
	}

/* donne l'adresse de la prochaine case  dfinir	*/
cas newcase(ob)
	objet	ob;
	{
	asm	{
		MOVEM.L	D1/A0,-(SP)
		MOVE.L	ob,A0
		ADD.L	OFEVEN(A0),A0
		MOVE.W	NCASE(A0),D1
		LEA.L	TBCASE(A0),A0
		BRA	@1
	@0	MOVE.W	SIZEC(A0),D0
		EXT.L	D0
		ADD.L	D0,A0
	@1	DBRA	D1,@0
		MOVE.L	A0,D0
		MOVEM.L	(SP)+,D1/A0
		}
	}

/* retourne les coordonnes cran (x,y) de l'objet ob	*/
void calcxy(ob,x,y)
	objet	ob;
	int	*x,*y;
	{
		mainp	r;
	*x=*y=0;
	do	{
		r=calcmainp(ob);
		*x+=r->xoe;
		*y+=r->yoe;
		}
	while(ob=ob->pere);
	}

/*<<<<<	'RAFRAICHISSEMENT' DE L'ECRAN	*/

/* initialise une fentre de rafrachissement	*/
void clearfenclc(f)
	fen	f;
	{
	f->g=0x8000;
	}

/* agrandit la fentre f pour qu'elle contienne la fentre g	*/
void ajfenclc(g,f)
	fen	g,f;
	{
	if (f->g!=0x8000)
		{
		if (g->g<f->g) f->g=g->g;
		if (g->h<f->h) f->h=g->h;
		if (g->d>f->d) f->d=g->d;
		if (g->b>f->b) f->b=g->b;
		}
		else
		{
		f->g=g->g; f->h=g->h; f->d=g->d; f->b=g->b;
		}
	}

struct Fen fn[8];

void inifn()
	{
		int	i;

	for (i=0;i<8;i++) fn[i].g=0x8000;
	sys->sizw=sizeof(struct Work);
	}

/* demande le rafrachissement de la zone f  la prochaine interruption
	ne pas utiliser directement dans une application	*/
void affzone(f)
	fen	f;
	{
		struct Fen	g,*p;
		int	i,j=0;
		long	k=0x7fffffff,m,n;

	n=(long)(f->d-f->g)*(long)(f->b-f->h);
	Bloque;
	for (i=0;i<8;i++)
		{
		p=&fn[i];
		if(p->g==0x8000) m=n;
		else	{
			g=*p;
			ajfenclc(f,&g);
			m=(long)(g.d-g.g)*(long)(g.b-g.h)
				-(long)(p->d-p->g)*(long)(p->b-p->h);
			}
		if (m<k)	{
			k=m; j=i;
			}
		}
	ajfenclc(f,&fn[j]);
	Debloque;
	}

/* rafrachit l'cran : utilis exclusivement pendant l'interruption	*/
void affn()
	{
		int	i;
	
	for (i=0;i<8;i++) if (fn[i].g!=0x8000)
			{
			affzonersc(&fn[i]);
			fn[i].g=0x8000;
			}
	}

/* demande le rafrachissement de tout l'cran  la prochaine interruption	*/
void affscreen()
	{
		struct Fen	f;

	f.g=0; f.h=0; f.d=sys->nbcl-1; f.b=sys->nbln-1;
	affzone(&f);
	}

/* demande le rafrachissement de l'objet ob  la prochaine interruption	*/
void affobjet(ob)
	objet	ob;
	{
		mainp	p=calcmainp(ob);
		struct Fen  f;

	calcxy(ob,&f.g,&f.h);
	f.d=f.g+p->largo; f.b=f.h+p->hauto;
	affzone(&f);
	}

/* demande le rafrachissement de la fentre f  la prochaine interruption	*/
void affenclc(f)
	fen	f;
	{
	if (f->g!= 0x8000) affzone(f);
	f->g=0x8000;
	}

/* demande l'affichage des dernires modifications de l'objet ob lors de la prochaine interruption */
void afworkmodif(ob)
	objet	ob;
	{
		mainp	p;
		fen	f;
		int	x,y;

	if (ob)	{
		p=calcmainp(ob);
		f=&ob->fen;
		if (f->g!=0x8000)
			{
			calcxy(ob,&x,&y);
			f->g+=x; f->d+=x; f->h+=y; f->b+=y;
			affzone(f);
			f->g=0x8000;
			}
		}
	}

/* agrandit la fentre f pour qu'elle contienne l'objet ob	*/
void ajobjclc(ob,f)
	objet	ob;
	fen	f;
	{
		struct Fen	g;
		mainp	a=calcmainp(ob);
	calcxy(ob,&g.g,&g.h);
	g.d=g.g + a->largo ; g.b=g.h + a->hauto ;
	ajfenclc(&g,f);
	}


/*<<<<<	GESTION DES OBJETS	*/

/* libre la mmoire bitmap de l'objet obj (usage personnel fortement dconseill)	*/
void freememwind(obj)
	objet	obj;
	{
		mainp	b=calcmainp(obj);

	if ((b->typo&0x2000)==0)
		{
		Bloque;
		Free ((void*)b->adbo);
		b->typo|=0x2000;
		Debloque;
		}
	}

/* demande de la mmoire pour y stocker le bitmap de l'objet ob
	(usage personnel dconseill, sauf pour crer un second buffer bitmap
	du mme objet)	*/
long askmemwind(obj)
	objet	obj;
	{
		mainp	b=calcmainp(obj);

	Bloque;
	if ((b->typo&0x2000)==0) freememwind(obj);
	
	b->largoo=(((b->largo)>>4)+1)*2;
	if (b->typo<0) b->largoo<<=1;
	b->adbo=(long) Malloc((long)b->largoo * (long)(1+ b->hauto));
	if (b->adbo) b->typo&=0xdfff;
		else
		{
		b->typo|=0x2000;
		SendError(-1,sys->psys);
		SendError(-1,sprocess);
		}
	Debloque;
	return b->adbo;
	}

/* empile l'objet ob sur le bureau,  la n-ime place	*/
void empile(ob,n)
	objet	ob;
	int	n;
	{
		objet	p=NULL,q=sys->debpile;
		int	i;
	Bloque;
	for(i=0;i<n;i++)
		if (q)	{
			p=q;
			q=q->nextp;
			}
	if (p) p->nextp=ob;
		else sys->debpile=ob;
	ob->prevp=p;
	if (q) q->prevp=ob;
	ob->nextp=q;
	sys->nbop++;
	Debloque;
	sys->flzone=-1;
	}

/* dpile l'objet ob du bureau et retourne sa position	*/
int depile(ob)
	objet	ob;
	{
		objet	q=sys->debpile;
		int	i=0;
	Bloque;
	while(q)	{
		if (q==ob)	{
			if (q->prevp) q->prevp->nextp=q->nextp;
				else sys->debpile=q->nextp;
			if (q->nextp) q->nextp->prevp=q->prevp;
			sys->nbop--;
			sys->flzone=-1;
			Debloque;
			return i;
			}
		q=q->nextp;
		i++;
		}
	Debloque;
	return -1;
	}

/* retourne l'adresse de l'objet qui se trouve  la n-ime position	*/
objet readpile(n)
	int	n;
	{
		objet	p=sys->debpile;
		int	i;
	Bloque;
	for(i=0;i<n;i++) if(p) p=p->nextp;
	Debloque;
	return p;
	}

/* retourne la position de l'objet ob dans la pile du bureau	*/
int placepile(ob)
	objet	ob;
	{
		objet	p=sys->debpile;
		int	i=0;
	Bloque;
	while(p)	{
		if (p==ob)	{
			Debloque;
			return i;
			}
		p=p->nextp;
		i++;
		}
	Debloque;
	return -1;
	}

/* demande de la mmoire pour y stocker les donnes relatives  un objet
	contenant nw 'work', nc 'cases', et bf registres 'tout usage'
	(usage fortement dconseill)	*/
objet askmemobj(bf,nw,nc)
	int	bf,nw,nc;
	{
		objet	ob;

	bf<<=2;
	Bloque;
	ob=(objet)Malloc(sizeof(struct Objet)+bf+sizeof(struct Mainp)
		+sizeof(struct Work)*nw+sizeof(struct Event)+sizeof(struct Case)*nc);
	if (ob)	{
		if(sys->listob) sys->listob->prev=ob;
		ob->next=sys->listob;
		ob->prev=NULL;
		sys->listob=ob;
		ob->ofmain=sizeof(struct Objet)+bf;
		ob->ofwork=ob->ofmain+sizeof(struct Mainp);
		ob->ofeven=ob->ofwork+sizeof(struct Work)*nw;
		ob->nwork=nw;
		clearfenclc(&ob->fen);
		ob->workcurs=0;
		ob->proc=process;
		ob->sproc=sprocess;
		ob->pere=NULL;
		calcmainp(ob)->typo=0x2000;
		}
		else
		{
		SendError(-1,sys->psys);
		SendError(-1,sprocess);
		}
	Debloque;
	return ob;
	}

/* libre la mmoire utilise pour stocker les caractristiques de l'objet ob
	(usage fortement dconseill)	*/
void freememobj(ob)
	objet	ob;
	{
	if ((calcmainp(ob)->typo&0x1000)==0)
		{
		Bloque;
		if (ob->next) ob->next->prev=ob->prev;
		if (ob->prev) ob->prev->next=ob->next;
			else	sys->listob=ob->next;
		Free((void*)ob);
		Debloque;
		}
	}

/* dtruit l'objet ob	*/
void killob(ob)
	objet	ob;
	{
	if (sys->obcsr==ob) sys->obcsr=NULL;
	if (depile(ob)>=0) affobjet(ob);
	freememwind(ob);
	freememobj(ob);
	}

/*	routine d'initialisation d'un objet sans masque
	(usage fortement dconseill)	*/
void initw(obj)
	objet	obj;
	{
	asm
		{
		MOVEM.L	D0-D7/A0-A6,-(SP)
		MOVE.L	obj,A5
		ADD.L	OFMAIN(A5),A5
		TST.W	TYPO(A5)
		BMI	@INITWF
		MOVE.L	ADBO(A5),A2
		MOVE.W	LARGOO(A5),D5
		EXT.L	D5
		MOVE.W	#0X8000,D6
		MOVE.W	LARGO(A5),D0
		AND.W	#15,D0
		LSR.W	D0,D6
		MOVE.W	HAUTO(A5),D7
		BSR	@LINEN
		SUBQ.W	#1,D7
		BMI	@INITWF
	@INITW0
		SUBQ.W	#1,D7
		BMI	@INITW1
		BSR	@LINEB
		BRA	@INITW0
	@INITW1
		BSR	@LINEN
	@INITWF
		MOVEM.L	(SP)+,D0-D7/A0-A6
		BRA	@FIN
	
	@LINEN
		MOVE.W	LARGO(A5),D1
		LSR.W	#4,D1
		MOVE.W	#-1,D0
		MOVE.L	A2,A0
	@LINEN0
		MOVE.W	D0,(A0)+
		DBRA	D1,@LINEN0
		ADD.L	D5,A2
		RTS
	@LINEB
		MOVE.L	A2,A0
		MOVE.W	LARGO(A5),D1
		LSR.W	#4,D1
	@LINEB0
		CLR.W	(A0)+
		DBRA	D1,@LINEB0
		OR.B	#128,(A2)
		OR.W	D6,-2(A0)
		ADD.L	D5,A2
		RTS
	
	@FIN
		}
	}

/* cration d'un objet de type 'fentre'
	largeur larg, hauteur haut, coordonnes (xi,yi), bf registres 'tout usage',
	nw 'work', nc 'cases'
	xi=0x8000 => coordonnes alatoires	*/
objet newwind(larg,haut,xi,yi,bf,nw,nc)
	int	larg,haut,xi,yi,bf,nw,nc;
	{
		objet	ob;
		mainp	p;
		work	q;
		event	r;
		int	i;

	if (nw==0) nw=1;
	ob=askmemobj(bf,nw,nc);
	if (ob)	{
		if (larg<15) larg=15;
		if (haut<15) haut=15;
		p=calcmainp(ob);
			p->typo|=0x4000;
			p->largo=larg; p->hauto=haut;
			p->xoe=xi; p->yoe=yi; p->deltax=p->deltay=0;
		if (xi==0x8000)
			{
			p->xoe=((long)(sys->nbcl-larg)*(long)rnd())>>8;
			p->yoe=((long)(sys->nbln-haut)*(long)rnd())>>8;
			}
		q=calcwork(ob);
			for (i=0;i<nw;i++)
			{
			q[i].xwmn=1; q[i].ywmn=1;
			q[i].xwmx=larg-1; q[i].ywmx=haut-1;
			q[i].xpen=0; q[i].ypen=0;
			q[i].xcur=0; q[i].ycur=0;
			q[i].fonte=sys->fontesys; q[i].inv=0xc;
			}
		calceven(ob)->ncase=0;
		if (askmemwind(ob))
			initw(ob);
			else
			{
			killob(ob);
			ob=NULL;
			}
		}
	return ob;
	}

/* rinitialise un objet de type fentre :
	bitmap rinitialis
	cases logiques effaces		*/
void clearwind(ob)
	objet	ob;
	{
		mainp	p;
		work	q;
		int	i;

	p=calcmainp(ob);
	q=calcwork(ob);
		for (i=0;i<ob->nwork;i++)
		{
		q[i].xwmn=1; q[i].ywmn=1;
		q[i].xwmx=p->largo-1; q[i].ywmx=p->hauto-1;
		q[i].xpen=0; q[i].ypen=0;
		q[i].xcur=0; q[i].ycur=0;
		q[i].fonte=sys->fontesys; q[i].inv=0xc;
		}
	calceven(ob)->ncase=0;
	initw(ob);
	}

/* cration d'un objet de type 'sprite'
	largeur larg, hauteur haut, coordonnes (xi,yi), bf registres 'tout usage',
	buff pointe sur le bitmap du sprite		*/
objet newsprite(larg,haut,xi,yi,bf,buff)
	int	larg,haut,xi,yi,bf;
	long	buff;
	{
		objet	ob;
		mainp	p;

	ob=askmemobj(bf,0,0);
	if (ob)	{
		larg|=15;
		p=calcmainp(ob);
			p->typo=0xA000;
			p->adbo=buff;
			p->largo=larg;
			p->largoo=((larg>>4)+1)<<2;
			p->hauto=haut;
			p->xoe=xi; p->yoe=yi;
		calceven(ob)->ncase=0;
		}
	return ob;
	}

/* dplace l'objet ob en (x,y) en assurant le rafrachissement de l'cran	*/
void deplaceob(ob,x,y)
	objet	ob;
	int	x,y;
	{
		struct Fen	f;
		mainp	p=calcmainp(ob);
	
	clearfenclc(&f);
	ajobjclc(ob,&f);
	p->xoe=x; p->yoe=y;
	ajobjclc(ob,&f);
	affenclc(&f);
	}


/* donne  l'objet ob de type fentre les dimensions dx,dy	*/
int agranditwind(ob,dx,dy)
	objet	ob;
	int	dx,dy;
	{
		mainp	p=calcmainp(ob);
		work	q=calcwork(ob);
		int	i;
		long	largoo;
		void	*b;
	Bloque;
	largoo=((dx>>4)+1)*2;
	b=Agrandmem((void*)p->adbo,largoo*(dy+1));
	if (b==NULL)
		{
		Debloque;
		return -1;
		}
	p->adbo=(long)b;
	p->largo=dx;
	p->hauto=dy;
	p->largoo=largoo;
	clearwind(ob);
	Debloque;
	return 0;
	}

/*<<<<<	ROUTINES GRAPHIQUES	*/

/* affiche le point (x,y) du work (ob,n) en 'couleur' c :
	c=0 : fond / c=1 : forme / c=2 : eor	*/
void pset(ob,n,x,y,c)
	objet	ob;
	int	n,x,y,c;
	{
		int	fl=0;
		struct Fen	f;
		int	sizw=sys->sizw;

	asm
		{
		MOVEM.L	D0-D1/A0-A2,-(SP)
		MOVE.L	ob,A2
		MOVE.L	A2,A1
		ADD.L	OFMAIN(A2),A1
		ADD.L	OFWORK(A2),A2
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A2
		TST.W	TYPO(A1)
		BMI	@FIN
		MOVE.W	y,D0
		CMP.W	YWMN(A2),D0
		BLT	@0
		CMP.W	YWMX(A2),D0
		BGT	@0
		MOVE.W	x,D1
		CMP.W	XWMN(A2),D1
		BLT	@0
		CMP.W	XWMX(A2),D1
		BGT	@0
		NOT.W	fl
		MULS	LARGOO(A1),D0
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A1),A0
		ADD.L	D0,A0
		MOVE.W	#0X8000,D0
		MOVE.W	x,D1
		AND.W	#15,D1
		LSR.W	D1,D0
		CMP.W	#2,c
		BNE	@1
		EOR.W	D0,(A0)
		BRA	@0
	@1	OR.W	D0,(A0)
		TST.W	c
		BNE	@0
		NOT.W	D0
		AND.W	D0,(A0)
	@0	MOVE.W	x,XPEN(A2)
		MOVE.W	y,YPEN(A2)
	@FIN	MOVEM.L	(SP)+,D0-D1/A0-A2
		}
	if (fl)
		{
		f.g=f.d=x; f.h=f.b=y;
		ajfenclc(&f,&ob->fen);
		}
	}

/* retourne l'tat du point (x,y) de l'objet ob :
	0 : fond / 1 : forme / -1 : point en dehors de la fentre	*/
int point(ob,x,y)
	objet	ob;
	int	x,y;
	{
	asm
		{
		MOVEM.L	D1/A0-A2,-(SP)
		MOVE.L	ob,A2
		MOVE.L	A2,A1
		ADD.L	OFMAIN(A2),A1
		TST.W	TYPO(A1)
		BMI	@0
		MOVE.W	y,D0
		BMI	@0
		CMP.W	HAUTO(A1),D0
		BGT	@0
		MOVE.W	x,D1
		BMI	@0
		CMP.W	LARGO(A1),D1
		BGT	@0
		MULS	LARGOO(A1),D0
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A1),A0
		ADD.L	D0,A0
		MOVE.W	#0X8000,D0
		MOVE.W	x,D1
		AND.W	#15,D1
		LSR.W	D1,D0
		AND.W	(A0),D0
		SNE	D0
		AND.W	#1,D0
		BRA	@1
	@0	MOVE.W	#-1,D0
	@1	MOVEM.L	(SP)+,D1/A0-A2
		}
	}

/* trace la ligne (x,y)-(xs,ys) dans le work (ob,n) en 'couleur' c :
	c=0 : fond		c=1 : forme		c=2 : eor	
	(valable mme lorsque la ligne dpasse de la fentre)	*/
void line(ob,n,x,y,xs,ys,c)
	objet	ob;
	int	n,x,y,xs,ys,c;
	{
		int	fl=0;
		struct Fen	f;
		int	sizw=sys->sizw;

	asm
		{
		movem.l	d0-d7/a0-a3,-(sp)
		move.l	ob,a3
		move.l	a3,a2
		add.l	OFMAIN(a3),a2
		add.l	OFWORK(a3),a3
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A3
		tst.w	TYPO(a2)
		bmi	@fin
		bsr	@test
		tst.w	d5
		bne	@7
		not.w	fl
		move.w	y,d0
		muls.w	LARGOO(a2),d0
		move.w	x,d1
		ext.l	d1
		asr.l	#4,d1
		lsl.l	#1,d1
		add.l	d1,d0
		move.l	ADBO(a2),a0
		add.l	d0,a0
		move.w	#0x8000,d0
		move.w	x,d1
		and.w	#15,d1
		lsr.w	d1,d0
		move.w	c,d2
		move.w	d0,d4
		btst	#1,d2
		beq	@l0
		clr.w	d4
		not.w	d2
	@l0	not.w	d4
		move.w	d0,d7
		btst	#0,d2
		bne	@l1
		clr.w	d7
	@l1	move.w	#1,d2
		move.w	xs,d3
		sub.w	x,d3
		bpl	@0
		neg.w	d3
		neg.w	d2
	@0	move.w	LARGOO(a2),d1
		ext.l	d1
		move.w	ys,d5
		sub.w	y,d5
		bpl	@1
		neg.w	d5
		neg.l	d1
	@1	move.l	d1,a1
		move.w	d3,d6
		cmp.w	d5,d6
		bhi	@3
		move.w	d5,d6
	@3	move.w	d5,d1
		lsr.w	#1,d1
		
	@2	add.w	d3,d1
	@8	and.w	d4,(a0)
		eor.w	d7,(a0)
		subq.w	#1,d6
		bmi	@7
		cmp.w	d5,d1
		blo	@6
		sub.w	d5,d1
		tst.w	d2
		bmi	@4
		ror.w	#1,d4
		ror.w	#1,d7
		ror.w	#1,d0
		bpl	@5
		addq.l	#2,a0
		bra	@5
	@4	rol.w	#1,d4
		rol.w	#1,d7
		rol.w	#1,d0
		bcc	@5
		subq.l	#2,a0
	@5	cmp.w	d5,d1
		bhs	@8
	@6	add.l	a1,a0
		bra	@2
	
	@test	move.w	#-1,d5
		move.w	x,d0
		move.w	y,d1
		bsr	@trsc
		move.w	d2,d7
		move.w	xs,d0
		move.w	ys,d1
		bsr	@trsc
		move.w	d2,d6
		and.w	d7,d2
		bne	@testf
		
		move.w	xs,d2
		sub.w	x,d2
		move.w	ys,d3
		sub.w	y,d3
		clr.w	d5
		tst.w	d7
		beq	@test1
		bsr	@trs
		tst.w	d5
		bne	@testf
		move.w	d0,x
		move.w	d1,y
	@test1	move.w	d6,d7
		beq	@testf
		bsr	@trs
		move.w	d0,xs
		move.w	d1,ys
	@testf	rts
	
	@trsc	clr.w	d2
		cmp.w	XWMN(a3),d0
		bge	@trc0
		addq.w	#2,d2
	@trc0	cmp.w	XWMX(a3),d0
		ble	@trc1
		addq.w	#1,d2
	@trc1	cmp.w	YWMN(a3),d1
		bge	@trc2
		addq.w	#8,d2
	@trc2	cmp.w	YWMX(a3),d1
		ble	@trc3
		addq.w	#4,d2
	@trc3	rts
	
	@trs	btst	#0,d7
		bne	@trd
		btst	#1,d7
		bne	@trg
	@trs0	btst	#2,d7
		bne	@trb
		btst	#3,d7
		bne	@trh
	@trs1	not.w	d5
	@trsf	rts
	
	@trg	move.w	XWMN(a3),d0
		bra	@trx
	@trd	move.w	XWMX(a3),d0
	@trx	move.w	d0,d1
		sub.w	x,d1
		muls.w	d3,d1
		divs.w	d2,d1
		add.w	y,d1
		cmp.w	YWMN(a3),d1
		blt	@trs0
		cmp.w	YWMX(a3),d1
		bgt	@trs0
		bra	@trsf
		
	@trh	move.w	YWMN(a3),d1
		bra	@try
	@trb	move.w	YWMX(a3),d1
	@try	move.w	d1,d0
		sub.w	y,d0
		muls.w	d2,d0
		divs.w	d3,d0
		add.w	x,d0
		cmp.w	XWMN(a3),d0
		blt	@trs1
		cmp.w	XWMX(a3),d0
		bgt	@trs1
		bra	@trsf
		
	@7	move.w	xs,XPEN(a3)
		move.w	ys,YPEN(a3)
	@fin	movem.l	(sp)+,d0-d7/a0-a3
		}
	if (fl)
		{
		if (x>xs) { f.g=xs; f.d=x; } else { f.g=x; f.d=xs; }
		if (y>ys) { f.h=ys; f.b=y; } else { f.h=y; f.b=ys; }
		ajfenclc(&f,&ob->fen);
		}
	}

/* trace une ligne depuis la position courante du crayon jusqu'en (x,y)
	dans le work (ob,n) en couleur c	*/
void lineto(ob,n,x,y,c)
	objet	ob;
	int	n,x,y,c;
	{
		work	p=calcwork(ob);

	line (ob,n,p[n].xpen,p[n].ypen,x,y,c);
	}

/* trace un vecteur (dx,dy)  partir de la position courante du crayon
	dans le work (ob,n) en couleur c	*/
void linedel(ob,n,x,y,c)
	objet	ob;
	int	n,x,y,c;
	{
		work	p=calcwork(ob);

	line (ob,n,p[n].xpen,p[n].ypen,p[n].xpen+x,p[n].ypen+y,c);
	}

/* trace le cadre (x,y)-(xx,yy) dans le work (ob,n) en couleur c	*/
void box(ob,n,x,y,xx,yy,c)
	objet	ob;
	int	n,x,y,xx,yy,c;
	{
	line(ob,n,x,y,xx,y,c);
	line(ob,n,xx,y,xx,yy,c);
	line(ob,n,x,yy,xx,yy,c);
	line(ob,n,x,y,x,yy,c);
	}

/* affiche le caractre ch dans le work (ob,n) en (x,y) (coordonnes bitmap du
	coin suprieur gauche)
	c=0 : normal / c<>0 : inverse video		
	( viter lorsque le curseur est apparent)	*/
void psetc(ob,n,x,y,ch,c)
	objet	ob;
	int	n,x,y,ch,c;
	{
		int	fl=0;
		struct	Fen f;
		work	w;
		int	sizw=sys->sizw;

	asm	{
		MOVEM.L	D0-D4/A0-A3,-(SP)
		MOVE.L	ob,A3
		MOVE.L	A3,A2
		ADD.L	OFMAIN(A3),A2
		ADD.L	OFWORK(A3),A3
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A3
		MOVE.L	A3,w
		TST.W	TYPO(A2)
		BMI	@FIN
		MOVE.L	FONTE(A3),A1
		MOVE.W	x,D0
		BMI	@FIN
		ADD.W	(A1),D0
		SUBQ.W	#1,D0
		CMP.W	LARGO(A2),D0
		BHI	@FIN
		MOVE.W	y,D1
		BMI	@FIN
		ADD.W	2(A1),D1
		SUBQ.W	#1,D1
		CMP.W	HAUTO(A2),D1
		BHI	@FIN
		
		NOT.W	fl
		MOVE.W	y,D0
		MULS	LARGOO(A2),D0
		MOVE.W	x,D1
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A2),A0
		ADD.L	D0,A0
		CLR.L	D2
		MOVE.W	4(A1),D2
		MOVE.W	x,D1
		AND.W	#15,D1
		ADDQ.W	#8,D1
		ROR.L	D1,D2
		NOT.L	D2
		
		MOVE.W	2(A1),D4
		MOVE.W	ch,D0
		AND.W	#255,D0
		MULU	D4,D0
		LEA.L	6(A1,D0.W),A1
		TST.W	c
		SNE	D3
		MOVE.W	LARGOO(A2),A3
		SUBQ.W	#1,D4
	@0	CLR.L	D0
		MOVE.B	(A1)+,D0
		EOR.B	D3,D0
		ROR.L	D1,D0
		AND.L	D2,(A0)
		OR.L	D0,(A0)
		ADD.L	A3,A0
		DBRA	D4,@0
	@FIN	MOVEM.L	(SP)+,D0-D4/A0-A3
		}
	if (fl)
		{
		f.g=x; f.h=y; f.d=x+w->fonte->larg-1; f.b=y+w->fonte->haut-1;
		ajfenclc(&f,&ob->fen);
		}
	}

/* affiche en eor le curseur du work (ob,n)
	(usage dconseill lorsque le curseur est actif (c--d clignote))	*/
void afcurs(ob,n)
	objet	ob;
	int	n;
	{
		int	fl=0;
		struct Fen	f;
		work	w;
		int	sizw=sys->sizw;

	asm	{
		MOVEM.L	D0-D2/A0-A3,-(SP)
		MOVE.L	ob,A3
		MOVE.L	A3,A2
		ADD.L	OFMAIN(A3),A2
		ADD.L	OFWORK(A3),A3
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A3
		MOVE.L	A3,w
		TST.W	TYPO(A2)
		BMI	@FIN
		MOVE.L	FONTE(A3),A1
		
		NOT.W	fl
		MOVE.W	YCUR(A3),D0
		MULS	2(A1),D0
		ADD.W	YWMN(A3),D0
		MULS	LARGOO(A2),D0
		MOVE.W	XCUR(A3),D1
		MULS	(A1),D1
		ADD.W	XWMN(A3),D1
		MOVE.W	D1,D2
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A2),A0
		ADD.L	D0,A0
		CLR.L	D1
		MOVE.W	4(A1),D1
		AND.W	#15,D2
		ADDQ.W	#8,D2
		ROR.L	D2,D1
		MOVE.W	2(A1),D0
		SUBQ.W	#1,D0
		MOVE.W	LARGOO(A2),A1
	@0	EOR.L	D1,(A0)
		ADD.L	A1,A0
		DBRA	D0,@0
	@FIN	EOR.W	#2,INV(A3)
		MOVEM.L	(SP)+,D0-D2/A0-A3
		}
	if (fl)
		{
		f.g=w->xcur*w->fonte->larg+w->xwmn; f.h=w->ycur*w->fonte->haut+w->ywmn;
		f.d=f.g+w->fonte->larg-1; f.b=f.h+w->fonte->haut-1;
		ajfenclc(&f,&ob->fen);
		}
	}

/* dsactive le curseur courant :
	arrte le clignotement
	affiche le curseur si bit 1 de work->inv vaut 1
	efface le curseur si bit 1 de work->inv vaut 0		*/
void effcurseur()
	{
		objet ob;
		work w;
		int n;

	Bloque;
	if ((ob=sys->obcsr)!=NULL)
		{
		w=calcworkn(ob,(n=ob->workcurs));
		sys->obcsr=NULL;
		if (((w->inv&2)&&((w->inv&4)==0))||(((w->inv&2)==0)&&(w->inv&4)))
			afcurs(ob,n);
		afworkmodif(ob);
		}
	Debloque;
	}


/* efface le work (ob,n)
	(usage dconseill si le curseur apparat : utiliser plutt le code ASCII 12)	*/
void cls(ob,n)
	objet	ob;
	int	n;
	{
		struct Fen f;
		work w;
		int	sizw=sys->sizw;

	asm	{
		MOVEM.L	D0-D7/A0-A4,-(SP)
		MOVE.L	ob,A3
		MOVE.L	A3,A2
		ADD.L	OFMAIN(A3),A2
		ADD.L	OFWORK(A3),A3
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A3
		MOVE.L	A3,w
		TST.W	TYPO(A2)
		BMI	@FIN
		MOVE.W	YWMN(A3),D0
		MULS	LARGOO(A2),D0
		MOVE.W	XWMN(A3),D1
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A2),A0
		ADD.L	D0,A0
		MOVE.W	LARGOO(A2),A4
		
		MOVE.W	XWMX(A3),D6
		LSR.W	#4,D6
		MOVE.W	XWMN(A3),D0
		LSR.W	#4,D0
		SUB.W	D0,D6
		SUBQ.W	#1,D6
		MOVE.L	#0XFFFF0000,D4
		MOVE.W	XWMN(A3),D0
		AND.W	#15,D0
		ASR.L	D0,D4
		MOVE.W	#0X7FFF,D5
		MOVE.W	XWMX(A3),D0
		AND.W	#15,D0
		LSR.W	D0,D5
	
		MOVE.W	YWMX(A3),D1
		SUB.W	YWMN(A3),D1
	@4	MOVEM.L	D6/A0,-(SP)
		AND.W	D4,(A0)+
		BRA	@6
	@5	CLR.W	(A0)+
	@6	DBRA	D6,@5
		AND.W	D5,(A0)
		MOVEM.L	(SP)+,D6/A0
		ADD.L	A4,A0
		DBRA	D1,@4
	@FIN	MOVEM.L	(SP)+,D0-D7/A0-A4
		}
	calcworkn(ob,n)->inv&=0xfffd;

	f.g=w->xwmn; f.h=w->ywmn; f.d=w->xwmx; f.b=w->ywmx;
	ajfenclc(&f,&ob->fen);
	}

/* inverse le bitmap de la case c de l'objet ob	*/
void notcase(ob,c)
	objet	ob;
	cas	c;
	{
		struct Fen	f;

	f.g=c->xcmn; f.h=c->ycmn; f.d=c->xcmx; f.b=c->ycmx;
	ajfenclc(&f,&ob->fen);
	asm	{
		MOVEM.L	D0-D7/A0-A4,-(SP)
		MOVE.L	c,A3
		MOVE.L	ob,A2
		ADD.L	OFMAIN(A2),A2
		MOVE.W	YCMN(A3),D0
		MULS	LARGOO(A2),D0
		MOVE.W	XCMN(A3),D1
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A2),A0
		ADD.L	D0,A0
		MOVE.W	LARGOO(A2),A4
		
		MOVE.W	XCMX(A3),D6
		LSR.W	#4,D6
		MOVE.W	XCMN(A3),D0
		LSR.W	#4,D0
		SUB.W	D0,D6
		SUBQ.W	#1,D6
		MOVE.W	#0XFFFF,D4
		MOVE.W	XCMN(A3),D0
		AND.W	#15,D0
		LSR.W	D0,D4
		MOVE.W	#0X8000,D5
		MOVE.W	XCMX(A3),D0
		AND.W	#15,D0
		ASR.W	D0,D5
		TST.W	D6
		BPL	@0
		AND.W	D5,D4
		CLR.W	D5
		CLR.W	D6
	@0	MOVE.W	YCMX(A3),D1
		SUB.W	YCMN(A3),D1
	@4	MOVEM.L	D6/A0,-(SP)
		EOR.W	D4,(A0)+
		BRA	@6
	@5	NOT.W	(A0)+
	@6	DBRA	D6,@5
		EOR.W	D5,(A0)
		MOVEM.L	(SP)+,D6/A0
		ADD.L	A4,A0
		DBRA	D1,@4
	@FIN	MOVEM.L	(SP)+,D0-D7/A0-A4
		}
	}

/* effectue un scrolling du work (ob,n)
	sens=0 : un caractre vers le haut
	sens=1 : un caractre vers le bas
	(usage dconseill : utiliser plutt les codes ASCII des flches	*/
void scroll(ob,n,sens)
	objet	ob;
	int	n,sens;
	{
		struct Fen	f;
		work	w;
		int	sizw=sys->sizw;

	asm
		{
		MOVEM.L	D0-D7/A0-A4,-(SP)
		MOVE.L	ob,A3
		MOVE.L	A3,A2
		ADD.L	OFMAIN(A3),A2
		ADD.L	OFWORK(A3),A3
		MOVE.W	n,D0
		MULU	sizw,D0
		ADD.L	D0,A3
		MOVE.L	A3,w
		TST.W	TYPO(A2)
		BMI	@FIN
		MOVE.L	FONTE(A3),A1
		MOVE.W	2(A1),D7
		MOVE.W	YWMN(A3),D0
		TST.W	sens
		BEQ	@L1
		MOVE.W	YWMX(A3),D0
	@L1	MULS	LARGOO(A2),D0
		MOVE.W	XWMN(A3),D1
		EXT.L	D1
		ASR.L	#4,D1
		LSL.L	#1,D1
		ADD.L	D1,D0
		MOVE.L	ADBO(A2),A0
		ADD.L	D0,A0
		MOVE.W	LARGOO(A2),D0
		TST.W	sens
		BEQ	@L2
		NEG.W	D0
	@L2	MOVE.W	D0,A4
		MULS	D7,D0
		LEA.L	(A0,D0.W),A1
		
		MOVE.W	XWMX(A3),D6
		LSR.W	#4,D6
		MOVE.W	XWMN(A3),D0
		LSR.W	#4,D0
		SUB.W	D0,D6
		SUBQ.W	#1,D6
		MOVE.L	#0XFFFF0000,D4
		MOVE.W	XWMN(A3),D0
		AND.W	#15,D0
		ASR.L	D0,D4
		MOVE.W	#0X7FFF,D5
		MOVE.W	XWMX(A3),D0
		AND.W	#15,D0
		LSR.W	D0,D5
		MOVE.W	D4,D2
		NOT.W	D2
		MOVE.W	D5,D3
		NOT.W	D3
	
		MOVE.W	YWMX(A3),D1
		SUB.W	YWMN(A3),D1
		ADDQ.W	#1,D1
		TST.W	sens
		BNE	@L3
		CLR.L	D0
		MOVE.W	D1,D0
		DIVU	D7,D0
		SWAP	D0
		ADD.W	D0,D7
		SUB.W	D7,D1
		BRA	@1
	@L3	SUB.W	D7,D1
		BRA	@1
	
	@L0	MOVEM.L	D6/A0/A1,-(SP)
		MOVE.W	(A1)+,D0
		AND.W	D2,D0
		AND.W	D4,(A0)
		OR.W	D0,(A0)+
		BRA	@3
	@2	MOVE.W	(A1)+,(A0)+
	@3	DBRA	D6,@2
		MOVE.W	(A1),D0
		AND.W	D3,D0
		AND.W	D5,(A0)
		OR.W	D0,(A0)
		MOVEM.L	(SP)+,D6/A0/A1
		ADD.L	A4,A0
		ADD.L	A4,A1
	@1	DBRA	D1,@L0
	
		SUBQ.W	#1,D7
	@4	MOVEM.L	D6/A0,-(SP)
		AND.W	D4,(A0)+
		BRA	@6
	@5	CLR.W	(A0)+
	@6	DBRA	D6,@5
		AND.W	D5,(A0)
		MOVEM.L	(SP)+,D6/A0
		ADD.L	A4,A0
		DBRA	D7,@4
	@FIN	MOVEM.L	(SP)+,D0-D7/A0-A4
		}
	f.g=w->xwmn; f.h=w->ywmn; f.d=w->xwmx; f.b=w->ywmx;
	ajfenclc(&f,&ob->fen);
	}

/*<<<<<	AFFICHAGE DE CARACTERES	*/

/* dplace le curseur du work (ob,n) vers le bas avec scrolling ventuel	*/
void depcbs(ob,n)
	objet	ob;
	int	n;
	{
		work	w=calcworkn(ob,n);

	w->ycur++;
	if (w->ywmn+(w->ycur+1)*w->fonte->haut-1>w->ywmx)
			{
			w->ycur--;
			scroll(ob,n,0);
			w->scroll--;
			}
	}

/* dplace le curseur du work (ob,n) vers le haut avec scrolling ventuel	*/
void depcht(ob,n)
	objet	ob;
	int	n;
	{
		work	w=calcworkn(ob,n);

	w->ycur--;
	if (w->ycur<0)	{
			w->ycur=0;
			scroll(ob,n,1);
			w->scroll++;
			}
	}

/* dplace le curseur du work (ob,n) vers la gauche	*/
void depcgh(ob,n)
	objet	ob;
	int	n;
	{
		work	w=calcworkn(ob,n);

	w->xcur--;
	if (w->xcur<0)	{
			w->xcur=(w->xwmx-w->xwmn+1)/w->fonte->larg-1;
			depcht(ob,n);
			}
	}

/* dplace le curseur du work (ob,n) vers la droite	*/
void depcdr(ob,n)
	objet	ob;
	int	n;
	{
		work	w=calcworkn(ob,n);

	w->xcur++;
	if (w->xwmn+(w->xcur+1)*w->fonte->larg-1>w->xwmx)
				{
				w->xcur=0;
				depcbs(ob,n);
				}
	}

/* affichage d'un caractre dans le work (ob,n)
	(ne pas utiliser directement : appeler plutt print)	*/
void printr(ob,n,ch)
	objet	ob;
	int	n,ch;
	{
		work	w=calcworkn(ob,n);

	if (ch>31)	{
		psetc(ob,n,w->xwmn+w->xcur*w->fonte->larg,w->ywmn+w->ycur*w->fonte->haut
			,ch,w->inv&1);
		depcdr(ob,n);
		}
	if ((ch==8) || (ch==0x1c)) depcgh(ob,n);	/* flche gauche	*/	
	if ((ch==9) || (ch==0x1d)) depcdr(ob,n);	/* flche droite	*/
	if ((ch==10) ||(ch==0x1f)) depcbs(ob,n);	/* flche bas	*/
	if ((ch==11) ||(ch==0x1e)) depcht(ob,n);	/* flche haut	*/
	if (ch==12)	{
		cls(ob,n);			/* cls	*/
		w->xcur=0; w->ycur=0;
		}
	if (ch==13) w->xcur=0;			/* retour charriot	*/
	if (ch==14) w->inv|=1;			/* passage en inverse video */
	if (ch==15) w->inv&=0xfffe;		/* retour au mode normal*/
	if (ch==26) w->xcur=w->ycur=0;		/* retour du curseur en haut  gauche */
	}

/* afficher le caractre ch dans le work (ob,n)	*/
void print(ob,n,ch)
	objet	ob;
	int	n,ch;
	{
		int	i;
		work	w=calcworkn(ob,n);

	Bloque;
	i=w->inv; w->inv&=0xfff7;
	Debloque;
	if (i&2) afcurs(ob,n);
	printr(ob,n,ch);
	if (i&2) afcurs(ob,n);
	if ((sys->obcsr==ob)&&(ob->workcurs==n)&&(i&8))
		{
		if ((i&2)==0) afcurs(ob,n);
		sys->comptc=clock();
		}
	w->inv|=i&8;
	}

/* afficher la chane de caractres chn dans le work (ob,n)	*/
void printchn(ob,n,chn)
	objet	ob;
	int	n;
	char	*chn;
	{
		char	*ch=chn;
		int	i;
		work	w=calcworkn(ob,n);

	Bloque;
	i=w->inv; w->inv&=0xfff7;
	Debloque;
	if (i&2) afcurs(ob,n);
	while ((*ch)!=0) printr(ob,n,(*(ch++)&255));
	if (i&2) afcurs(ob,n);
	if ((sys->obcsr==ob)&&(ob->workcurs==n)&&(i&8))
		{
		if ((i&2)==0) afcurs(ob,n);
		sys->comptc=clock();
		}
	w->inv|=i&8;
	}

/* afficher la chane de caractres chn dans le work (ob,n)	puis passer  la ligne*/
void println(ob,n,chn)
	objet	ob;
	int	n;
	char	*chn;
	{
	printchn(ob,n,chn);
	print(ob,n,13); print(ob,n,10);
	}

/* afficher la valeur de l'entier n dans le work (ob,nw) en hexadcimal	*/
void printhexint(ob,nw,n)
	objet	ob;
	int	nw,n;
	{
		int	m,s,i,c;

	m=0xf000;
	s=12;
	for (i=0;i<4;i++)
		{
		c=((n&m)>>s) &15;
		if (c>9) c+=7;
		print(ob,nw,c+48);
		m>>=4;
		s-=4;
		}
	}

/* afficher la valeur de l'entier long n dans le work (ob,nw) en hexadcimal	*/
void printhexlong(ob,nw,n)
	objet	ob;
	int	nw;
	long	n;
	{
		int	i=n>>16;

	printhexint(ob,nw,i);
	printhexint(ob,nw,n);
	}

/* placer le curseur du work (ob,n) en (x,y) (coordonnes curseur et non bitmap :
	(0,0) correspond au caractre plac en haut  gauche dans le work (ob,n)	*/
void locate(ob,n,x,y)
	objet	ob;
	int	n,x,y;
	{
		int	i;
		work	w=calcworkn(ob,n);

	Bloque;
	i=w->inv; w->inv&=0xfff7;
	Debloque;
	if (i&2) afcurs(ob,n);
		x%=(w->xwmx-w->xwmn+1)/w->fonte->larg;
		y%=(w->ywmx-w->ywmn+1)/w->fonte->haut;
		w->xcur=x;w->ycur=y;
	if (i&2) afcurs(ob,n);
	w->inv|=i&8;
	}

/* redfinir les coordonnes du work (ob,n) comme tant (xn,yn)-(xx,yx)
	le curseur est replac  l'origine	*/
void console(ob,n,xn,yn,xx,yx)
	objet	ob;
	int	n,xn,yn,xx,yx;
	{
		int	i;
		work	w=calcworkn(ob,n);

	Bloque;
	i=w->inv; w->inv&=0xfff7;
	Debloque;
	if (i&2) afcurs(ob,n);
	w->xwmn=xn; w->ywmn=yn;
	w->xwmx=xx; w->ywmx=yx;
	w->xcur=0;w->ycur=0;
	if (i&2) afcurs(ob,n);
	w->inv|=i&8;
	}

/* retourne la longueur de la chane chn	*/
int len(chn)
	char	*chn;
	{
		int	i=0;

	while(chn[i++]);
	return i-1;
	}

/* modifie le dessin du n-ime caractre de la fonte 'fonte'
	ch pointe sur un tableau char[] contenant le nouveau dessin
	(fonction DEFGR$)	*/
void defgr(fonte,n,ch)
	font	fonte;
	int	n;
	char	*ch;
	{
		int	i;
		char	*c;
	
	c=&fonte->cod[n*fonte->haut];
	for(i=0;i<fonte->haut;i++) *(c++)=*(ch++);
	}

/* cre le sprite standard de la souris	*/
objet inicsrstand()
	{
		objet	obj;
		long	adbo;
		mainp	p;

	asm	{
		LEA.L	@DESS,A0
		MOVE.L	A0,adbo
		BRA	@FIN
	@DESS	DC.W	0X3FFF,0X0000,0X1FFF,0X4000,0X0FFF,0X6000,0X07FF,0X7000,0X03FF,0X7800,0X01FF,0X7C00,0X00FF,0X7E00,0X007F,0X7F00
		DC.W	0X003F,0X7F80,0X007F,0X7C00,0X01FF,0X6C00,0X10FF,0X4600,0XB0FF,0X0600,0XF87F,0X0300,0XF87F,0X0300,0XFCFF,0X0000
	@FIN	}
	
	obj=newsprite(15,15,0,0,0,adbo);
	if (obj)	{
		p=calcmainp(obj);
		p->deltax=1;
		p->deltay=1;
		}
	return obj;
	}
