#include "desk.h"

/* Programme Othello
	mthode alpha-bta	*/

/* structure d'un plateau de jeu :
	2 bits par case, 1 dans a[], 1 dans b[]
	a[] : pions du joueur 'a'
	na : nombre de pions du joueur 'a'
	b[], nb : idem pour joueur 'b'
	who indique qui est le joueur 'a' (blanc ou noir)	*/
struct Jeu	{
	char	a[8];
	int	na;
	char	b[8];
	int	nb;
	int	who;
	};
typedef struct Jeu	*jeu;

/* paramtres communs aux sous-processus	*/
struct Othello
	{
	objet	plateau;
	cas	endc,square,levelb,leveln,rev;
	struct Jeu	jeux[100];
	int	actuel;
	int	level[2];
	int	master;
	};
typedef struct Othello *othel;

#define JEUA	0
#define NPIONA	8
#define JEUB	10
#define NPIONB	18
#define WHO	20

/* dessine la case (x,y) du jeu je dans l'objet ob	*/
void afcas(ob,je,x,y)
	objet	ob;
	jeu	je;
	int	x,y;
{
		
	asm	{
		MOVEM.L	D0-D1/A0-A2,-(SP)
		LEA.L	@CASN,A1
		LEA.L	@CASB,A0
		MOVE.L	je,A2
		TST.W	WHO(A2)
		BEQ	@AFCAS0
		EXG	A0,A1
	@AFCAS0	MOVE.W	y,D0
		MOVE.W	x,D1
		BTST	D1,JEUA(A2,D0.W)
		BNE	@AFCAS1
		EXG	A0,A1
		BTST	D1,JEUB(A2,D0.W)
		BNE	@AFCAS1
		LEA.L	@CASV,A1
	@AFCAS1	MOVE.L	ob,A2
		ADD.L	OFMAIN(A2),A2
		MOVE.L	ADBO(A2),A0
		LSL.W	#5,D0
		ADD.W	#24,D0
		MULU	LARGOO(A2),D0
		LSL.L	#2,D1
		ADDQ.L	#2,D1
		ADD.W	D1,D0
		LEA.L	(A0,D0.W),A0
		MOVE.W	LARGOO(A2),D0
		EXT.L	D0
		MOVEQ	#31,D1
	@AFCAS2	MOVE.L	(A1)+,(A0)
		ADD.L	D0,A0
		DBRA	D1,@AFCAS2
		MOVEM.L	(SP)+,D0-D1/A0-A2
		BRA	@FIN
		
		/* dessin de la case vide */
	@CASV	DC.L	0XFFFFFFFF,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB
		DC.L	0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB
		DC.L	0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB
		DC.L	0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XAAAAAAAB,0XD5555555,0XFFFFFFFF
		/* case avec pion noir */
	@CASN	DC.L	0XFFFFFFFF,0XAAAAAAAB,0XD55FF555,0XAAF00EAB,0XD58001D5,0XAA00006B,0XD4000035,0XA800001B
		DC.L	0XD8000015,0XB000000B,0XD000000D,0XB000000B,0XE0000005,0XA0000007,0XE0000005,0XA0000007
		DC.L	0XE0000005,0XA0000007,0XE0000005,0XA0000007,0XD000000D,0XB000000B,0XD000000D,0XA800001B
		DC.L	0XD8000015,0XAC00002B,0XD6000055,0XAB8001AB,0XD5700F55,0XAAAFFAAB,0XD5555555,0XFFFFFFFF
		/* case avec pion blanc	*/
	@CASB	DC.L	0XFFFFFFFF,0XAAAAAAAB,0XD5500555,0XAA8FF0AB,0XD47FFE55,0XA9FFFFAB,0XD3FFFFD5,0XA7FFFFEB
		DC.L	0XD7FFFFE5,0XAFFFFFF3,0XCFFFFFF5,0XAFFFFFF3,0XDFFFFFF9,0X9FFFFFFB,0XDFFFFFF9,0X9FFFFFFB
		DC.L	0XDFFFFFF9,0X9FFFFFFB,0XDFFFFFF9,0X9FFFFFFB,0XCFFFFFF5,0XAFFFFFF3,0XCFFFFFF5,0XA7FFFFEB
		DC.L	0XD7FFFFE5,0XABFFFFCB,0XD5FFFF95,0XAA7FFE2B,0XD50FF155,0XAAA00AAB,0XD5555555,0XFFFFFFFF

	@FIN
		}
	}


/* recopie le plateau de jeu 'je' vers le suivant en permutant les joueurs a et b	*/
void copytab(je)
	jeu	je;
	{
		jeu	je1=je+1;
		
	asm	{
		MOVEM.L	D0-D1/A0-A1,-(SP)
		MOVE.L	je,A0
		MOVE.L	je1,A1
		MOVEM.L	JEUA(A0),D0/D1
		MOVEM.L	D0/D1,JEUB(A1)
		MOVE.W	NPIONA(A0),NPIONB(A1)
		MOVEM.L	JEUB(A0),D0/D1
		MOVEM.L	D0/D1,JEUA(A1)
		MOVE.W	NPIONB(A0),NPIONA(A1)
		MOVE.W	WHO(A0),WHO(A1)
		NOT.W	WHO(A1)
		MOVEM.L	(SP)+,D0-D1/A0-A1
		}
	}

/* joue le coup (x,y) dans le jeu 'je', pour le joueur 'a'
	retourne le nombre de pions gagns (0 si coup impossible)	*/
int joue(je,x,y)
	jeu	je;
	int	x,y;
	{
		int	tbjoue[64];

	asm	{
		MOVEM.L	D1-D4/A0-A3,-(SP)
		CLR.W	D0
		MOVE.W	x,D1
		MOVE.W	y,D2
		MOVE.L	je,A0
		BTST	D1,JEUA(A0,D2.W)
		BNE	@TESTF
		BTST	D1,JEUB(A0,D2.W)
		BNE	@TESTF
		LEA.L	@TBDIR,A1
		LEA.L	tbjoue,A3
		MOVEQ	#7,D3
	@TEST0	MOVE.W	x,D1
		MOVE.W	y,D2
		MOVE.L	A3,A2
		CLR.W	D4
	@TEST1	ADD.W	(A1),D1
		CMP.W	#7,D1
		BHI	@TEST3
		ADD.W	2(A1),D2
		CMP.W	#7,D2
		BHI	@TEST3
		BTST	D1,JEUB(A0,D2.W)
		BEQ	@TEST2
		MOVE.W	D1,(A2)+
		MOVE.W	D2,(A2)+
		ADDQ.W	#1,D4
		BRA	@TEST1
	@TEST2	BTST	D1,JEUA(A0,D2.W)
		BEQ	@TEST3
		TST.W	D4
		BEQ	@TEST3
		ADD.W	D4,D0
		MOVE.L	A2,A3
	@TEST3	ADDQ.L	#4,A1
		DBRA	D3,@TEST0
		TST.W	D0
		BEQ	@TESTF
		SUB.W	D0,NPIONB(A0)
		ADD.W	D0,NPIONA(A0)
		ADDQ.W	#1,NPIONA(A0)
		MOVE.W	x,(A3)+
		MOVE.W	y,(A3)+
		MOVE.W	D0,D3
	@REVERSE	MOVE.W	-(A3),D2
		MOVE.W	-(A3),D1
		BSET	D1,JEUA(A0,D2.W)
		BCLR	D1,JEUB(A0,D2.W)
		DBRA	D3,@REVERSE
		BRA	@TESTF
	
	@TBDIR	DC.W	1,0,1,1,0,1,-1,1,-1,0,-1,-1,0,-1,1,-1

	@TESTF	MOVEM.L	(SP)+,D1-D4/A0-A3
		}
	}

/* test si le joueur 'a' peut jouer en (x,y) dans le jeu 'je'
	0 si impossible	*/
int testcoup(je,x,y)
	jeu	je;
	int	x,y;
	{
		int	tbjoue[64];

	asm	{
		MOVEM.L	D1-D3/A0-A1,-(SP)
		CLR.W	D0
		MOVE.W	x,D1
		MOVE.W	y,D2
		MOVE.L	je,A0
		BTST	D1,JEUA(A0,D2.W)
		BNE	@TESTF
		BTST	D1,JEUB(A0,D2.W)
		BNE	@TESTF
		LEA.L	@TBDIR,A1
		MOVEQ	#7,D3
	@TEST0	CLR.W	D0
		MOVE.W	x,D1
		MOVE.W	y,D2
	@TEST1	ADD.W	(A1),D1
		CMP.W	#7,D1
		BHI	@TEST3
		ADD.W	2(A1),D2
		CMP.W	#7,D2
		BHI	@TEST3
		BTST	D1,JEUB(A0,D2.W)
		BEQ	@TEST2
		MOVEQ	#1,D0
		BRA	@TEST1
	@TEST2	BTST	D1,JEUA(A0,D2.W)
		BEQ	@TEST3
		TST.W	D0
		BNE	@TESTF
	@TEST3	ADDQ.L	#4,A1
		DBRA	D3,@TEST0
		CLR.W	D0
		BRA	@TESTF
	
	@TBDIR	DC.W	1,0,1,1,0,1,-1,1,-1,0,-1,-1,0,-1,1,-1

	@TESTF	MOVEM.L	(SP)+,D1-D3/A0-A1
		}
	}

/* retourne le nombre de possibilits du joueur 'a' dans le jeu 'je'	*/
int nbposs(je)
	jeu	je;
	{
		int	x,y,k=0;
	
	for(x=0;x<8;x++) for(y=0;y<8;y++) k+=testcoup(je,x,y);
	return k;
	}

/* recalcule et affiche le plateau de jeu 'je'	*/
void afftab(ob,je)
	objet	ob;
	jeu	je;
	{
		int	x,y;
	
	for(x=0;x<8;x++) for(y=0;y<8;y++) afcas(ob,je,x,y);
	locate(ob,0,38,4-3*je->who); printhexint(ob,0,je->na);
	locate(ob,0,38,7+3*je->who); printhexint(ob,0,je->nb);
	affobjet(ob);
	}

/* fonction d'valuation du jeu je
	n=0 : vu du joueur 'a'
	n=1 : vu du joueur 'b'	*/
int Evaluation(je,n)
	jeu	je;
	int	n;
	{
		jeu	jee=je+1;
		int	dx,dy,fl;
		
	copytab(je);
	asm	{
		MOVEM.L	D1-D7/A0-A4,-(SP)
		MOVE.L	je,A2
		LEA.L	JEUA(A2),A4
		LEA.L	JEUB(A2),A3
		MOVE.W	NPIONA(A2),D4
		MOVE.W	D4,D5
		ADD.W	NPIONB(A2),D4
		SUB.W	NPIONB(A2),D5
		CMP.W	#40,D4
		BLT	@EVAL0
		LSL.W	#1,D5
	@EVAL0	CMP.W	#58,D4
		BGT	@EVALF
		MOVE.L	jee,-(SP)
		JSR	nbposs
		ADDQ.L	#4,SP
		CMP.W	#45,D4
		BGT	@2
		LSL.W	#1,D0
	@2	SUB.W	D0,D5
		BSR	@TSTFRT
		SUB.W	D0,D5
		CMP.W	#40,D4
		BGT	@EVAL1
		SUB.W	D0,D5
	@EVAL1	BSR	@TSTBRD
		ADD.W	D0,D5
	
		EXG.L	A3,A4
		BSR	@TSTBRD
		SUB.W	D0,D5
	@EVALF	MOVE.W	D5,D0
		TST.W	n
		BEQ	@EVALFF
		NEG.W	D0
		BRA	@EVALFF
	
	@TSTFRT	CLR.W	D0
		MOVEQ	#6,D7
	@TSTFR1	MOVEQ	#6,D6
	@TSTFR2	MOVE.W	#1,fl
		BTST	D6,(A4,D7.W)
		BNE	@TSTFR2A
		NEG.W	fl
		BTST	D6,(A3,D7.W)
		BEQ	@TSTFRF
	@TSTFR2A	LEA.L	@TBDIR,A0
		MOVE.W	#3,D3
	@TSTFR3	MOVE.W	D7,D2
		MOVE.W	D6,D1
		ADD.W	(A0),D1
		ADD.W	2(A0),D2
		BTST	D1,(A4,D2.W)
		BNE	@TSTFR4
		BTST	D1,(A3,D2.W)
		BNE	@TSTFR4
		ADD.W	fl,D0
		BRA	@TSTFRF
	@TSTFR4	ADDQ.L	#4,A0
		DBRA	D3,@TSTFR3
	@TSTFRF	SUBQ.W	#1,D6
		BNE	@TSTFR2
		SUBQ.W	#1,D7
		BNE	@TSTFR1
		RTS
	
	@TBDIR	DC.W	1,0,0,1,-1,0,0,-1
	
	@TSTBRD	CLR.W	D0
		CLR.W	D6
		CLR.W	D7
		MOVE.W	#1,dx
		MOVE.W	#1,dy
		BSR	@TSTBRSC
		MOVE.W	#7,D6
		NEG.W	dx
		BSR	@TSTBRSC
		MOVE.W	#7,D7
		NEG.W	dy
		BSR	@TSTBRSC
		CLR.W	D6
		NEG.W	dx
		BSR	@TSTBRSC
	
		LEA.L	@TBCOT,A0
		CLR.W	fl
	@TSTB0	MOVE.W	(A0),D1
		MOVE.W	2(A0),D2
		BTST	D1,(A4,D2.W)	
		BNE	@TSTB1
		BTST	D1,(A3,D2.W)
		BNE	@TSTB1
		TST.W	fl
		BEQ	@TSTB3
		MOVE.W	-8(A0),D6
		MOVE.W	-6(A0),D7
		MOVE.W	-4(A0),dx
		MOVE.W	-2(A0),dy
		BSR	@TSTCOT
	@TSTB3	MOVE.W	#1,fl
		BRA	@TSTB2
	@TSTB1	CLR.W	fl
	@TSTB2	ADD.L	#12,A0
		TST.W	-8(A0)
		BPL	@TSTB0
		RTS
	
	@TBCOT	DC.W	0,0,0,0,1,0
		DC.W	7,0,7,0,0,1
		DC.W	7,7,0,7,1,0
		DC.W	0,7,0,0,0,1,0,0,-1
	
	@TSTBRSC	MOVE.W	D6,D1
		MOVE.W	D7,D2
		BTST	D6,(A4,D7.W)
		BNE	@TSBND
		BTST	D6,(A3,D7.W)
		BNE	@TSBF
		ADD.W	dx,D1
		ADD.W	dy,D2
		BTST	D1,(A4,D7.W)
		BEQ	@TSB0
		SUB.W	#15,D0
	@TSB0	BTST	D6,(A4,D2.W)
		BEQ	@TSB1
		SUB.W	#15,D0
	@TSB1	BTST	D1,(A4,D2.W)
		BEQ	@TSBF
		SUB.W	#30,D0
	@TSBF	RTS
	@TSBND	ADD.W	dx,D1
		CMP.W	#7,D1
		BHI	@TSBN0
		BTST	D1,(A4,D7.W)
		BEQ	@TSBN0
		ADDQ.W	#5,D0
		BRA	@TSBND
	@TSBN0	ADD.W	dy,D2
		CMP.W	#7,D2
		BHI	@TSBN1
		BTST	D6,(A4,D2.W)
		BEQ	@TSBN1
		ADDQ.W	#5,D0
		BRA	@TSBN0
	@TSBN1	ADD.W	#30,D0
		RTS
	
	@TSTCOT	MOVEQ	#6,D3
		CLR.W	fl
	@TSTC1	ADD.W	dx,D6
		ADD.W	dy,D7
		BTST	D6,(A4,D7.W)
		BNE	@TSTC2
		BTST	D6,(A3,D7.W)
		BEQ	@TSTCF
		BSET	#0,fl
		BCLR	#1,fl
		BTST	#2,fl
		BEQ	@TSTCF
		ADDQ.W	#5,D0
		BCLR	#2,fl
		BRA	@TSTCF
	@TSTC2	ADDQ.W	#2,D0
		BTST	#1,fl
		BEQ	@TSTC3
		ADDQ.W	#3,D0
	@TSTC3	BSET	#1,fl
		BTST	#0,fl
		BEQ	@TSTCF
		BSET	#2,fl
	@TSTCF	DBRA	D3,@TSTC1
		RTS
	
	@EVALFF	MOVEM.L	(SP)+,D1-D7/A0-A4
		}
	}

/* minimax avec alpha-bta	*/
int Eval(je,n,ni,last)
	jeu	je;
	int	n;
	int	ni;
	int	last;
	{
		jeu	jee=je+1;
		int	i,j,eval,ev;

	if (n==0) return Evaluation(je,(ni+1)&1);
	copytab(je);
	if ((n+ni)&1) 
		{
		eval=0x7fff;
		for(i=0;i<8;i++) for(j=0;j<8;j++)
			{
			if (joue(jee,i,j))
				{
				ev=Eval(jee,n-1,ni,eval);
				if (ev<eval) eval=ev;
				copytab(je);
				if (eval<last) return eval;
				}
			}
		if (eval==0x7fff) return Eval(jee,n-1,ni,eval);
		}
		else
		{
		eval=0x8000;
		for(i=0;i<8;i++) for(j=0;j<8;j++)
			{
			if (joue(jee,i,j))
				{
				ev=Eval(jee,n-1,ni,eval);
				if (ev>eval) eval=ev;
				copytab(je);
				if (eval>last) return eval;
				}
			}
		if (eval==0x8000) return Eval(jee,n-1,ni,eval);
		}
	return eval;
	}

/* valuation des diffrents coups possibles	*/
int Brain(je,x,y,ni)
	jeu	je;
	int	*x,*y;
	int	ni;
	{
		jeu	jee=je+1;
		int	i,j,eval,ev;

	copytab(je);
	eval=0x8000;
	for(i=0;i<8;i++) for(j=0;j<8;j++)
		{
		if (joue(jee,i,j))
			{
			ev=Eval(jee,ni-1,ni,eval);
			if (ev>eval)
				{
				eval=ev;
				*x=i;
				*y=j;
				}
			copytab(je);
			}
		}
	return eval;
	}

/* initialise le plateau de jeu	*/
void iniothello(oth)
	othel	oth;
	{
		objet	ob;
		int	i;
	
	for (i=0;i<8;i++) oth->jeux[0].a[i]=oth->jeux[0].b[i]=0;
	oth->jeux[0].a[3]=0x08; oth->jeux[0].a[4]=0x10;
	oth->jeux[0].b[4]=0x08; oth->jeux[0].b[3]=0x10;
	oth->jeux[0].na=oth->jeux[0].nb=2;
	oth->jeux[0].who=-1;
	oth->actuel=0;
	oth->level[0]=0;
	oth->level[1]=0;
		
	empile(ob=oth->plateau,1);
	oth->endc=setbarre(ob,"othello",sprocess);
	oth->square=newcvide(ob,0,16,25,256+15,256+24,0,0,0,sprocess,Nid);
	oth->levelb=newc(ob,0," Blancs  ",288,9+6*8,2,0,0,sprocess,Nid);
	oth->leveln=newc(ob,0," Noirs   ",288,9+3*8,2,0,0,sprocess,Nid);
	oth->rev=newc(ob,0," Revient ",288,9+10*8,2,0,1,sprocess,Nid);
	oth->master=sprocess;
	notcase(ob,oth->leveln);
	for(i=1;i<9;i++)
		{
		psetc(ob,0,5,4+32*i,48+i,0);
		psetc(ob,0,32*i-4,14,64+i,0);
		}
	locate(ob,0,36,15); printchn(ob,0,"Evaluation");
	locate(ob,0,36,18); printchn(ob,0,"Precedent");
	afftab(ob,&oth->jeux[oth->actuel]);
	}

/* sous-processus charg de dterminer le coup  jouer :
	- attend que le joueur humain choisisse (si c'est son tour)
	- lance la rflexion de l'ordinateur (si c'est son tour)
  dans tous les cas, retourne une comm de type 'CInt' au sous-processus principal, contenant le coup
  	choisi	*/
void interf()
	{
		othel	oth=(othel)GetParam();
		objet	ob=oth->plateau;
		int	l,x,y,k;
		Mouse	m;
		
	l=oth->level[oth->actuel&1];
	oth->square->clk=sprocess;
	
	if (l==0)		/* joueur humain	*/
		{
		while(1)	{
			k=WaitforComm(CClick);	/* attend le click	*/
			GetClick(&m);
			if (m.ca==oth->square)
				{
				SendInt( ((m.dx>>5)<<3)+(m.dy>>5)
					,oth->master);
					/* envoye le coup */
				}
			}
		}
		else
		{		/*  rflexion de l'ordinateur	*/
		SetMaskComm(0);
		locate(ob,0,38,16); printchn(ob,0,"????");
		afworkmodif(ob);
		locate(ob,0,38,16); printhexint(ob,0,
			Brain(&oth->jeux[oth->actuel],&x,&y,l));
		afworkmodif(ob);
		SendInt((x<<3)+y,oth->master);
		}
	WaitforComm(0);
	}

/* sous-processus attendant que l'on clique sur la case de destruction	*/
void testfin()
	{
		othel	oth=GetParam();
		long	k;
		Mouse	m;
	
	oth->endc->clk=sprocess;
	while(1)	{
		k=WaitforComm(CClickE);
		GetClickE(&m);
		if ((m.ca==oth->endc)&&(confirmation("Quit ?",0)))
			EndProcess();	/* fin de l'application 'othello'	*/
		}
	}

/* point d'entre de othello : sous-processus principal	*/
void othello()
{
	struct Othello oth;
	objet	ob;
	Mouse	m;
	int	k,i,j,n;
	int	inter1;

oth.plateau=newwind(400,291,0x8000,0,0,0,10);
if (oth.plateau==NULL) EndProcess();
iniothello(&oth);
ob=oth.plateau;
inter1=CreateSProcess(interf,30,4096,(void*)&oth);
CreateSProcess(testfin,30,1024,(void*)&oth);

while(1)	{
	k=WaitforComm(CInt+CClick+CClickE);
	
	if (k==CClickE)
		{	/* revenir d'un coup en arrire	*/
		GetClickE(&m);
		if ((m.ca==oth.rev)&&(oth.actuel>0))
			{
			KillSProcess(inter1);
			SetMaskComm(0);
			oth.actuel--;
			notcase(ob,oth.leveln);
			notcase(ob,oth.levelb);
			afftab(ob,&oth.jeux[oth.actuel]);
			inter1=CreateSProcess(interf,30,4096,(void*)&oth);
			}
		}
	if (k==CInt)
		{	/* rception d'une proposition de coup	*/
		KillSProcess(inter1);
		i=GetInt();
		copytab(&oth.jeux[oth.actuel]);
		if (testcoup(&oth.jeux[oth.actuel+1],(i>>3)&7,i&7))
			{
				/* clignotement du nouveau pion	*/
			for(j=0;j<4;j++)
				{
				oth.jeux[oth.actuel+1].a[i&7]+=1<<((i>>3)&7);
				afftab(ob,&oth.jeux[oth.actuel+1]);
				n=clock();
				while((clock()-n)<4);
				oth.jeux[oth.actuel+1].a[i&7]-=1<<((i>>3)&7);
				afftab(ob,&oth.jeux[oth.actuel+1]);
				n=clock();
				while((clock()-n)<4);
				}				
			joue(&oth.jeux[oth.actuel+1],(i>>3)&7,i&7);
			oth.actuel++;
			locate(ob,0,39,19);
			print(ob,0,65+((i>>3)&7));
			print(ob,0,49+(i&7));
			notcase(ob,oth.leveln);
			notcase(ob,oth.levelb);
			afftab(ob,&oth.jeux[oth.actuel]);
			}
		copytab(&oth.jeux[oth.actuel]);
				/* teste si le joueur suivant doit passer	*/
		if (nbposs(&oth.jeux[oth.actuel+1]))
			inter1=CreateSProcess(interf,30,4096,(void*)&oth);
			else
			{
			oth.actuel++;
			locate(ob,0,39,19);
			printchn(ob,0,"--");
			copytab(&oth.jeux[oth.actuel]);
				/* teste si personne ne peut jouer	*/
			if (nbposs(&oth.jeux[oth.actuel+1]))
				inter1=CreateSProcess(interf,30,4096,(void*)&oth);
			notcase(ob,oth.leveln);
			notcase(ob,oth.levelb);
			afftab(ob,&oth.jeux[oth.actuel]);
			}
		}
	if (k==CClick)
		{
		GetClick(&m);
		if (m.ca==oth.leveln)
			{	/* changement de niveau des noirs	*/
			i=menuder(ob,oth.leveln,10,11,oth.level[0]+1,NULL,
			 "Joueur","Niv. 1","Niv. 2","Niv. 3","Niv. 4","Niv. 5",
			"Niv. 6","Niv. 7","Niv. 8","Niv. 9","Niv.10");
			if ((i)&&(i!=oth.level[0]+1))
				{
				if (oth.actuel&1)
					oth.level[0]=i-1;
					else
					{
				/* recommence la rflexion avec un nouveau niveau */
					KillSProcess(inter1);
					oth.level[0]=i-1;
					inter1=CreateSProcess(interf,30
					,4096,(void*)&oth);
					}
				}
			}
		if (m.ca==oth.levelb)
			{	/* idem joueur blanc	*/
			i=menuder(ob,oth.levelb,10,11,oth.level[1]+1,NULL,
			 "Joueur","Niv. 1","Niv. 2","Niv. 3","Niv. 4","Niv. 5",
			"Niv. 6","Niv. 7","Niv. 8","Niv. 9","Niv.10");
			if ((i)&&(i!=oth.level[1]+1))
				{
				if ((oth.actuel&1)==0)
					oth.level[1]=i-1;
					else
					{
					KillSProcess(inter1);
					oth.level[1]=i-1;
					inter1=CreateSProcess(interf,30
					,4096,(void*)&oth);
					}
				}
			}
		}	
	}
}
