#include "desk.h"

/*	GESTION DE LA MEMOIRE	*/

struct Mem	M1,M2;

/* initialisation de la gestion mmoire	*/
void *Inimem()
	{
		void	*b;
		mem	p,q;
	
	sys->sizemem=sizeof(struct Mem);	
	b=malloc(sizebuff);
	sys->first=p=&M1;
	p->deb=NULL;
	p->end=b;
	p->np=-1;
	q=&M2;
	q->deb=(void*)((long)b+sizebuff+sys->sizemem);
	q->end=NULL;
	q->next=NULL;
	q->np=-1;
	p->next=q;
	return b;
	}

/* demande un bloc mmoire de longueur l au nom du process n
	retourne NULL si impossible	*/
void *Malloc1(l,n)
	long	l;
	int	n;
	{
		mem	q,p=sys->first,m;
		long	k=sys->sizemem*2;
	
	if (l==0) l=2;
	if (l&1) l++;
	Bloque;
	while(q=p->next)
		{
		if ((long)q->deb-(long)p->end>=l+k)
			{
			m=(mem)(p->end);
			m->deb=(void*)((long)m+sys->sizemem);
			m->end=(void*)((long)m->deb+l);
			m->np=n;
			m->next=q;
			p->next=m;
			Debloque;
			return m->deb;
			}
		p=q;
		}
	Debloque;
	return NULL;
	}

/* demande un bloc mmoire de longueur l
	retourne NULL si impossible	*/
void *Malloc(l)
	long	l;
	{
	return Malloc1(l,process);
	}

/* libre le bloc b	*/
int Free(b)
	void	*b;
	{
		mem	q,p=sys->first;
	
	Bloque;
	while(q=p->next)
		{
		if (q->deb==b)
			{
			p->next=q->next;
			Debloque;
			return 0;
			}
		p=q;
		}
	Debloque;
	return -1;
	}

/* retourne le n-ime bloc mmoire de la liste des allocations	*/
mem memn(n)
	int	n;
	{
		int	i;
		mem	p=sys->first;
	
	Bloque;
	for(i=0;i<n;i++) if(p) p=p->next;
	Debloque;
	return p;
	}

/* retourne la taille du plus grand bloc encore allouable	*/ 
long Maxmem()
	{
		mem	q,p=sys->first;
		long	l=0,m;
	
	Bloque;
	while(q=p->next)
		{
		m=(long)q->deb-(long)p->end;
		if (m>l) l=m;
		p=q;
		}
	Debloque;
	return l-sys->sizemem*2;
	}

/* retourne la taille maximale que l'on peut donner au bloc b
	(en l'augmentant d'un ct vers les adresses basses et de l'autre ct
	vers les adresses hautes)	*/
long Maxagrandmem(b)
	void	*b;
	{
		mem	r,q,p=sys->first;
		long	l=0,m;
		long	k=sys->sizemem*2;

	Bloque;
	while(q=p->next)
		{
		if(p->deb==b) m=(long)q->deb-(long)r->end;
			else
			m=(long)q->deb-(long)p->end;
		if (m>l) l=m;
		r=p; p=q;
		}
	Debloque;
	return l-sys->sizemem*2;
	}

/* agrandit le bloc b  la taille l (avec changement ventuel de l'adresse du bloc).
	ne change rien et retourne NULL si impossible	*/
void *Agrandmem(b,l)
	void	*b;
	long	l;
	{
		mem	m,r,q,p=sys->first;
		void	*mm;
		long	k=sys->sizemem*2;
	
	if (l==0) l=2;
	if (l&1) l++;
	Bloque;
	while(q=p->next)
		{
		if((p->deb==b)&&((long)q->deb-(long)r->end>=l+k))
				{
				m=(mem)r->end;
				m->deb=(void*)((long)m+sys->sizemem);
				m->end=(void*)((long)m->deb+l);
				m->np=p->np;
				m->next=p->next;
				r->next=m;
				Debloque;
				return m->deb;
				}
		r=p; p=q;
		}
	Debloque;
	if (mm=Malloc(l)) Free(b);
	return mm;
	}

/*	ROUTINES DE COMMUNICATION INTER-PROCESS	*/

/* initialise la gestion des communications	*/
void IniComm()
	{
		int	i;

	sys->bcomm=(comm)malloc(sizeof(Comm)*nmaxcomm);
	for (i=0;i<nmaxcomm-1;i++) (sys->bcomm)[i].next=&(sys->bcomm)[i+1];
	(sys->bcomm)[nmaxcomm-1].next=NULL;
	sys->firstcomm=sys->bcomm;
	}

/* demande un nouveau bloc de communication */
comm GetcaseComm()
	{
		comm	c=NULL;
	Bloque;
	if(c=sys->firstcomm) sys->firstcomm=c->next;
	Debloque;
	return c;
	}

/* rend un bloc de communication */
void BackcaseComm(c)
	comm	c;
	{
	Bloque;
	c->next=sys->firstcomm;
	sys->firstcomm=c;
	Debloque;
	}

/* lit une comm dans la file d'attente du sous-process en cours
	avec le masque msk
	(aprs traitement, il faudra 'rendre' la comm par BackcaseComm() )	*/
comm ReadComm(msk)
	long	msk;
	{
		sproc	p=(sys->sid)[sprocess];
		comm 	d=NULL,c=p->chncomm;

	while(c)	{
		if (msk & c->type)
			{
			Bloque;
			if (d==NULL)
				p->chncomm=c->next;
				else
				d->next=c->next;
			if (p->endcomm==c) p->endcomm=d;
			Debloque;
			return c;
			}
		d=c;
		c=c->next;
		}
	return NULL;
	}

/* envoie la comm c vers le destinataire n :
	n=Defaut	: lit le process destinataire dans la table de comm par dfaut : tbcomm[]
	n=ID de processus : lit le sous-processus destinataire dans la table de comm par dfaut
			du processus n
	n=ID de sous-processus : envoye la comm, si le masque le permet
	n=Nid : communication avorte
	retourne l'ID du destinataire si succs, Nid si chec	*/
int SendComm(c,n)
	comm	c;
	int	n;
	{
		int	j,k;
		comm	d;
		int	np;
		sproc	q;

	Bloque;
	np=Nid;
	if (n==Defaut) np=n=(sys->tbcomm)[c->type];  /* dtermine le processus destinataire : np*/
		else
		if (present(n))
			{
			if ((sys->sid)[n]->typ) np=(sys->sid)[n]->pere;
				else
				np=n;
			}
	if ( (!present(np))||((j=(sys->pid)[np]->fl)==-1) ) /* processus destinataire valide ? */
		{
		Debloque;
		BackcaseComm(c);
		return Nid;			/* non */
		}		/* dtermine le sous-processus destinataire : n */
	if (np==n) n=(sys->pid)[np]->tbcomm[c->type];
	c->type=1<<c->type;
	if (	(!present(n))||		/* sous-processus valide ? */
		((k=(q=(sys->sid)[n])->fls)==-1)||
		((q->maskcomm & c->type)==0)	) /* masque ok ? */
		{
		Debloque;
		BackcaseComm(c);
		return Nid;			/* non */
		}
	c->np=process;
	c->nsp=sprocess;
	d=q->endcomm;
	if (d==NULL) q->chncomm=c;	/* ajoute la comm dans la liste de rception */ 
		else
		d->next=c;
	q->endcomm=c;

	if (k==2) q->fls=1;		/* libre le sous-processus s'il tait en attente */
	if (j==2) (sys->pid)[np]->fl=1;	/* libre le processus s'il tait en attente */
	Debloque;
	return n;		/* retourne l'ID du destinataire */
	}

/* modifie le masque de rception du sous-processus courant	*/
void SetMaskComm(msk)
	long	msk;
	{
		comm	c;

	(sys->sid)[sprocess]->maskcomm=msk;
	msk=-1-msk;
	while(c=ReadComm(msk)) BackcaseComm(c);
	}

/* lit le masque de rception du sous-processus courant	*/
long GetMaskComm()
	{
	return (sys->sid)[sprocess]->maskcomm;
	}

/* retourne le numro du premier bit non nul de n	*/
int FirstBit(n)
	long	n;
	{
	asm	{
		MOVE.L	D1,-(SP)
		MOVE.L	n,D1
		MOVEQ	#31,D0
	@1	LSR.L	#1,D1
		DBCS	D0,@1
		NEG.W	D0
		ADD.W	#31,D0
		MOVE.L	(SP)+,D1
		}
	}

/* positionne la table des comm par dfaut du systme pour que le processus courant
	reoive les comm de type i	*/
void ReceiveP(i)
	long	i;
	{
	(sys->tbcomm)[FirstBit(i)]=process;
	}

/* positionne la table des comm par dfaut du processus courant pour que le sous-processus courant
	reoive les comm de type i	*/
void ReceiveSP(i)
	long	i;
	{
	(sys->pid)[process]->tbcomm[FirstBit(i)]=sprocess;
	(sys->sid)[sprocess]->maskcomm|=i;
	}

/* lit une comm dans la liste de rception (avec masque m) et la copie dans c
	(c est une variable de l'utilisateur)	*/
int GetComm(c,m)
	comm	c;
	long	m;
	{
		comm	d=ReadComm(m);
	if (d)	{
		*c=*d;
		BackcaseComm(d);
		return 1;
		}
	return 0;
	}

/* envoye un entier i avec le type t vers nsp (plusieurs types de comm correspondent  un entier :
	CInt, CError, CClock ...
	(ne pas utiliser directement)	*/
int SendWord(i,t,nsp)
	int	i,t;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=t; c->next=NULL; c->data.i=i;
	return SendComm(c,nsp);
	}

/* lit un entier dans une comm de type t
	(ne pas utiliser directement	*/
int GetWord(t)
	long	t;
	{
		int	i=0x8000;
		comm	c=ReadComm(t);
	if (c)	{
		i=c->data.i;
		BackcaseComm(c);
		}
	return i;
	}

/* envoyer un entier i vers nsp	*/
int SendInt(i,nsp)
	int	i;
	int	nsp;
	{
	return SendWord(i,0,nsp);
	}

/* lire un entier dans la liste de rception
	retourne 0x8000 si aucune comm de type CInt dans la liste	*/
int GetInt()
	{
	return GetWord(CInt);
	}
	

/* envoyer un caractre i vers nsp	*/
int SendChar(i,nsp)
	int	i;
	int	nsp;
	{
	return SendWord(i,10,nsp);
	}

/* lire un caractre dans la liste de rception
	retourne 0x8000 si aucune comm de type CChar dans la liste	*/
int GetChar()
	{
	return GetWord(CChar);
	}

/* envoyer une valeur d'horloge i vers nsp	*/
int SendClock(i,nsp)
	int	i;
	int	nsp;
	{
	return SendWord(i,11,nsp);
	}

/* lire une valeur d'horloge dans la liste de rception
	retourne 0x8000 si aucune comm de type CClock dans la liste	*/
int GetClock()
	{
	return GetWord(CClock);
	}

/* envoyer un code erreur i vers nsp	*/
int SendError(i,nsp)
	int	i;
	int	nsp;
	{
	return SendWord(i,3,nsp);
	}

/* lire un code erreur dans la liste de rception
	retourne 0 si aucune comm de type CError dans la liste	*/
int GetError()
	{
		int	i=GetWord(CError);
	if (i==0x8000) i=0;
	return i;
	}

/* envoyer un entier long l vers nsp	*/
int SendLong(l,nsp)
	long	l;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=1; c->next=NULL; c->data.l=l;
	return SendComm(c,nsp);
	}

/* lire un entier long dans la liste de rception
	retourne 0x80000000 si aucune comm de type CLong dans la liste	*/
long GetLong()
	{
		long	l=0x80000000;
		comm	c=ReadComm(CLong);

	if (c)	{
		l=c->data.l;
		BackcaseComm(c);
		}
	return l;
	}

/* envoyer un pointeur p vers nsp	*/
int SendPoint(p,nsp)
	void	*p;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=2; c->next=NULL; c->data.q=p;
	return SendComm(c,nsp);
	}

/* lire un pointeur dans la liste de rception
	retourne NULL si aucune comm de type CPnt dans la liste	*/
void *GetPoint()
	{
		void	*p=NULL;
		comm	c=ReadComm(CPoint);

	if (c)	{
		p=c->data.q;
		BackcaseComm(c);
		}
	return p;
	}

/* envoyer un bloc fichier f vers nsp
	(ne pas utiliser directement : passer par les fonctions volues - fichier utildesk) */
int SendFile(f,nsp)
	File	*f;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=4; c->next=NULL; c->data.f=*f;
	return SendComm(c,nsp);
	}

/* lire un bloc f dans la liste de rception
	retourne NULL si aucune comm de type CFile dans la liste
	(ne pas utiliser)	*/
int GetFile(f)
	File	*f;
	{
		comm	d=ReadComm(CFile);

	
	if (d)	{
		*f=d->data.f;
		BackcaseComm(d);
		return 1;
		}
	return 0;
	}

/* envoyer un bloc Mouse vers nsp
	(ne pas utiliser : appeler les routines qui suivent)	*/
int SendM(objv,casv,dx,dy,i,nsp)
	objet	objv;
	cas	casv;
	int	i,dx,dy;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=i; c->next=NULL;
	c->data.m.ob=objv; c->data.m.ca=casv;
	c->data.m.dx=dx; c->data.m.dy=dy;
	return SendComm(c,nsp);
	}

/* envoyer une comm 'entre de zone' vers nsp
	(la souris vient d'entrer dans la case casv de l'objet objv)	*/
int SendEnter(objv,casv,nsp)
	objet	objv;
	cas	casv;
	int	nsp;
	{
	return SendM(objv,casv,0,0,6,nsp);
	}

/* envoyer une comm 'sortie de zone' vers nsp
	(la souris vient de quitter la case casv de l'objet objv)	*/
int SendQuit(objv,casv,nsp)
	objet	objv;
	cas	casv;
	int	nsp;
	{
	return SendM(objv,casv,0,0,7,nsp);
	}

/* envoyer une comm 'Click' vers nsp
	(click de la souris sur le point (dx,dy) de la case casv de l'objet objv)	*/
int SendClick(objv,casv,dx,dy,nsp)
	objet	objv;
	cas	casv;
	int	dx,dy;
	int	nsp;
	{
	return SendM(objv,casv,dx,dy,8,nsp);
	}

/* envoyer une comm 'Fin de Click' vers nsp
	(fin click de la souris sur le point (dx,dy) de la case casv de l'objet objv)	*/
int SendClickE(objv,casv,dx,dy,nsp)
	objet	objv;
	cas	casv;
	int	dx,dy;
	int	nsp;
	{
	return SendM(objv,casv,dx,dy,9,nsp);
	}

/* envoyer une comm 'n-ime Click' vers nsp
	(n-ime click de la souris sur la case casv de l'objet objv)	*/
int SendClickn(objv,casv,n,nsp)
	objet	objv;
	cas	casv;
	int	n;
	int	nsp;
	{
	return SendM(objv,casv,n,0,13,nsp);
	}

/* lire un bloc Mouse dans la liste de rception et le recopier dans m (variable utilisateur)
	(ne pas utiliser : appeler les routines qui suivent)	*/
int GetM(i,m)
	long	i;
	Mouse	*m;
	{
		comm	c=ReadComm(i);

	if (c)	{
		*m=c->data.m;
		BackcaseComm(c);
		return 0;
		}
	return -1;
	}

/* lire un bloc mouse de type 'entre de zone'	*/
int GetEnter(m)
	Mouse	*m;
	{
	return GetM(CEnter,m);
	}

/* lire un bloc mouse de type 'sorite de zone'	*/
int GetQuit(m)
	Mouse	*m;
	{
	return GetM(CQuit,m);
	}

/* lire un bloc mouse de type 'click'	*/
int GetClick(m)
	Mouse	*m;
	{
	return GetM(CClick,m);
	}

/* lire un bloc mouse de type 'fin de click'	*/
int GetClickE(m)
	Mouse	*m;
	{
	return GetM(CClickE,m);
	}

/* lire un bloc mouse de type 'n-ime click'	*/
int GetClickn(m)
	Mouse	*m;
	{
	return GetM(CClickn,m);
	}

/* envoye un couple d'entiers (x,y) vers nsp	*/
int SendMove(x,y,nsp)
	int	x,y;
	int	nsp;
	{
		comm	c=GetcaseComm();

	if (c==NULL) return Nid;
	c->type=5; c->next=NULL;
	c->data.p.h=x; c->data.p.v=y;
	return SendComm(c,nsp);
	}

/* lire un couple d'entiers dans la liste de rception
	retourne -1 si aucune comm de type CMove dans la liste	*/
int GetMove(p)
	Point	*p;
	{
		comm	c=ReadComm(CMove);

	if (c)	{
		*p=c->data.p;
		BackcaseComm(c);
		return 0;
		}
	return -1;
	}

/* envoye le contenu du buffer p de longueur l vers nsp	*/
int SendData(p,l,nsp)
	void	*p;
	long	l;
	int	nsp;
	{
		comm	c=GetcaseComm();
		long	i;
		int	*pp,*q,*qq;
		int	k;
		mem	m;
	
	if (c==NULL) return Nid;
	q=Malloc(l);
	if (q==NULL) return Nid;
	pp=(int*)p;
	qq=(int*)q;
	for(i=0;i<l;i+=2) *(qq++)=*(pp++);
	
	c->type=12; c->next=NULL;
	c->data.d.p=q; c->data.d.l=l;

	Bloque;
	k=SendComm(c,nsp);
	if (k==Nid)	Free(q);
		else
		{
		m=(mem)((long)q-sys->sizemem);
		m->np=k;
		}
	Debloque;
	return k;
	}

/* rceptionne un buffer depuis la liste de rception (longueur l)
	retourne NULL si aucune comm de type CMove dans la liste
	ce buffer a t cr par un Malloc, et le bloc mmoire est 
		au nom du processus receveur : ne pas oublier un Free() aprs traitement */
void *GetData(l)
	long	*l;
	{
		comm	c=ReadComm(CData);
		void	*p;
		
	if (c)	{
		p=c->data.d.p;
		*l=c->data.d.l;
		BackcaseComm(c);
		return p;
		}
	return NULL;
	}


/*	ROUTINES PROCESSUS	*/

/* initialise la gestion des processus	*/
void Iniprocess()
	{
		int	i;

	(sys->pid)=(proc*) malloc(nmaxid*sizeof(proc));
	(sys->sid)=(sproc*) (sys->pid);
	sys->pntid=0;
	for(i=0;i<nmaxid;i++) (sys->pid)[i]=NULL;

	sys->pro=Nid;
	sys->total=sys->calcu=0;
	for (i=0;i<32;i++) (sys->tbcomm)[i]=Nid;
	}

/* demande un nouvel ID correspondant  l'adresse l
	(a priori, l'utilisateur n'en a pas besoin)	*/
int NewID(l)
	void	*l;
	{
		int	i=0,d=2*nmaxid;
	
	Bloque;
	while((sys->pid)[sys->pntid])
		{
		if ((sys->pid)[sys->pntid]==Hot) (sys->pid)[sys->pntid]=NULL;
		sys->pntid++; i++;
		if (sys->pntid==nmaxid) sys->pntid=0;
		if (i==d)	{
			Debloque;
			return Nid;
			}
		}
	i=sys->pntid;
	(sys->pid)[i]=(proc)l;
	sys->pntid++;
	if (sys->pntid==nmaxid) sys->pntid=0;
	Debloque;
	return i;
	}

/* Cre un sous-processus fils du processus d'ID k
	(utiliser plutt la routine suivante)	*/
int CreateSProcess1(p,level,n,pnt,k)
	void	(*p)();
	int	level;
	long	n;
	void	*pnt;
	int	k;
	{
		sproc	r;
		void	*l;
		int	m;

	if( ((l=Malloc1(n+sizeof(struct SProcess),k))==NULL)||((m=NewID(l))==Nid) )
		{
		if (l) Free(l);
		SendError(-1,sys->psys);
		SendError(-1,sprocess);
		return -1;
		}
	r=(sproc)l;
	l=(void*)((long)l+sizeof(struct SProcess));
	r->typ=-1;
	r->fls=1;
	r->chncomm=NULL;
	r->maskcomm=0;
	r->prs=level;
	r->kprios=0;
	r->endcomm=NULL;
	r->param=pnt;
	r->flclock=0;
	r->pere=k;
	asm		/* cre l'amorce de la pile systme du nouveau sous-process */
		{
		MOVEM.L	A0/A1,-(SP)
		MOVE.L	r,A1
		MOVE.L	l,A0
		ADD.L	n,A0
		MOVE.W	#0X64,-(A0)
		MOVE.L	p,-(A0)
		MOVE.W	#0X2000,-(A0)
		MOVEM.L	D0-D7/A1-A6,-(A0)
		MOVE.L	D0,-(A0)
		MOVE.L	A0,SPP(A1)
		MOVEM.L	(SP)+,A0/A1
		}
	Bloque;
	r->prev=Nid;
	r->next=(sys->pid)[k]->spro;
	if(r->next!=Nid) (sys->sid)[r->next]->prev=m;
	(sys->pid)[k]->spro=m;
	Debloque;
	return m;
	}

/* Cre un nouveau sous-processus frre
	p : adresse de la routine  excuter
	level : niveau de priorit
	n : taille de la pile systme
	pnt : pointeur vers un bloc de paramtres que l'on passe au sous-processus	*/
int CreateSProcess(p,level,n,pnt)
	void	(*p)();
	int	level;
	long	n;
	void	*pnt;
	{
	return CreateSProcess1(p,level,n,pnt,process);
	}

/* Cre un nouveau process
	name : nom (15 lettres maxi)
	lev : niveau de priorit du processus
	p, level, n, pnt : caractristiques du premier sous-processus de ce nouveau processus */
int CreateProcess(name,lev,p,level,n,pnt)
	char	*name;
	int	lev;
	void	(*p)();
	int	level;
	long	n;
	void	*pnt;
	{
		int	j;
		proc	r;
		char	*ch="no name";
		mem	m;
		int	k;

	r=(proc)Malloc(sizeof(struct Process));	
	if (r==NULL) return Nid;
	k=NewID((void*)r);
	if (k==Nid)	{
		Free((void*)r);
		return Nid;
		}
	r->typ=0;
	r->fl=1;
	r->pr=lev;
	if (name==NULL) name=ch;
	j=0;
	while(name[j])
		{
		r->name[j]=name[j];
		j++;
		}
	while(j<15) r->name[j++]=32;
	r->name[15]=0;
	
	for (j=0;j<32;j++) r->tbcomm[j]=Nid;
	r->kprio=r->totals=r->calcs=0;
	r->comptsp=Nid;
	r->spro=Nid;
	
	Bloque;
	if (CreateSProcess1(p,level,n,pnt,k)!=Nid)
		{
		r->prev=Nid;
		r->next=sys->pro;
		if (sys->pro!=Nid) (sys->pid)[sys->pro]->prev=k;
		sys->pro=k;
		m=(mem)((long)r-sys->sizemem);
		m->np=k;
		Debloque;
		return k;
		}
	Free((void*)r);
	(sys->pid)[k]=NULL;
	Debloque;
	return Nid;
	}

/* dtermine si l'ID nsp est encore valide
	1:oui / 0:non	*/
int present(nsp)
	int	nsp;
	{
		proc	p;
	
	if (nsp==Nid) return 0;
	p=(sys->pid)[nsp];
	if ((p==NULL)||(p==Hot)) return 0;
	return 1;
	}

/* dtruit le sous-processus nsp
	(ne pas utiliser : appeler plutt la routine suivante)	*/
int KillSProcess1(nsp)
	int	nsp;
	{
		int	i,np;
		comm	c,d;
		proc	p;
		sproc	q;

	if (!present(nsp)) return -1;
	Bloque;
	q=(sys->sid)[nsp];
	(sys->pid)[nsp]=Hot;
	np=q->pere;		/* dtermine le processus pre */
	p=(sys->pid)[np];		/* s'enlve de la liste des fils du processus pre */
	if (q->next!=Nid) (sys->sid)[q->next]->prev=q->prev;
	if (q->prev!=Nid) (sys->sid)[q->prev]->next=q->next;
		else p->spro=q->next;
	c=q->chncomm;
	while (c)	{	/* dtruit les comm de la liste de rception */
		d=c->next;
		if (c->type==CData) Free((void*)c->data.d.l);
		BackcaseComm(c);
		c=d;
		}
			/* s'enlve de la liste des comm par dfaut */
	for(i=0;i<32;i++) if (p->tbcomm[i]==nsp) p->tbcomm[i]=Nid;
	Free((void*)q);
	if (p->spro==Nid) i=np;
		else i=-2;
	Debloque;
	return i;
	}

/* dtruit le sous-process nsp
	et dtruit le processus pre s'il ne reste plus de sous-processus
	( utiliser pour dtruire un AUTRE sous-processus : pour se dtruire soi-mme,
	utiliser EndSProcess() )	*/
int KillSProcess(nsp)
	int	nsp;
	{
		int	i;
	Bloque;
	i=KillSProcess1(nsp);
	if (i>=0) KillProcess(i);
	Debloque;
	}

/* dtruit le processus np
	( utiliser pour dtruire un AUTRE processus : pour se dtruire soi-mme,
	utiliser EndProcess() )	*/
int KillProcess(np)
	int	np;
	{
		int	j;
		objet	q,p;
		mem	g,f;
		int	r,s;
		proc	pp;
	
	if (!present(np)) return -1;
	Bloque;
	pp=(sys->pid)[np];
	r=pp->spro;
	while(r!=Nid)	/* dtruit tous les sous-processus */
		{
		s=(sys->sid)[r]->next;
		KillSProcess1(r);
		r=s;
		}
	(sys->pid)[np]=Hot;	/* s'enlve de la liste des processus */
	if (pp->next!=Nid) (sys->pid)[pp->next]->prev=pp->prev;
	if (pp->prev!=Nid) (sys->pid)[pp->prev]->next=pp->next;
		else sys->pro=pp->next;
			/* s'enlve de la liste des comm par dfaut */
	for(j=0;j<32;j++) if ((sys->tbcomm)[j]==np) (sys->tbcomm)[j]=Nid;
	
	p=sys->listob;
	while(p)	{	/* dtruit les objets affilis au processus */
		q=p->next;
		if (p->proc==np) killob(p);
		p=q;
		}
			/* ferme fichiers ouverts par le processus */ 
	for(j=0;j<nmaxfil;j++) if ((sys->filep)[j]==np) Fclose((sys->Fl)[j]);
	
	f=sys->first;
	while(g=f->next)	/* libre les blocs mmoire affilis au processus */
		{
		if (f->np==np) Free(f->deb);
		f=g;
		}
	Debloque;
	}

/* suspend le sous-processus nsp
	(qui ne doit pas tre le sous-processus en cours)	*/
void SuspendSProcess(nsp)
	int	nsp;
	{
	if ((present(nsp))&&(nsp!=sprocess)) (sys->sid)[nsp]->fls=-1;
	}

/* suspend le processus np
	(qui ne doit pas tre le processus en cours)	*/
void SuspendProcess(np)
	int	np;
	{
	if ((present(np))&&(np!=process)) (sys->pid)[np]->fl=-1;
	}

/* place le sous-processus courant en attente d'une comm de type compatible avec le masque msk
	retourne le type de la premire comm en accord avec le masque	*/
long WaitforComm(msk)
	long	msk;
	{
	SetMaskComm(msk);
	while((sys->sid)[sprocess]->chncomm==NULL) (sys->sid)[sprocess]->fls=2;
	(sys->sid)[sprocess]->fls=1;
	return (sys->sid)[sprocess]->chncomm->type;
	}

/* fin d'un sous-processus : le sous-processus se dtruit */
void EndSProcess()
	{
	Bloque;
	KillSProcess(sprocess);
	sprocess=process=Nid;
	Debloque;
	while(1);
	}

/* fin d'un processus : le processus se dtruit */
void EndProcess()
	{
	Bloque;
	KillProcess(process);
	sprocess=process=Nid;
	Debloque;
	while(1);
	}

/* donne la priorit level au sous-process nsp	*/
void LevelSProcess(nsp,level)
	int	nsp;
	int	level;
	{
	if (present(nsp)) (sys->sid)[nsp]->prs=level;
	}

/* donne la priorit level au process np	*/
void LevelProcess(np,level)
	int	np;
	int	level;
	{
	if (present(np)) (sys->pid)[np]->pr=level;
	}

/* continue le droulement du sous-process nsp
	(si celui-ci avait t suspendu)	*/
void ContinueSProcess(nsp)
	int	nsp;
	{
	if (present(nsp)) (sys->sid)[nsp]->fls=1;
	}

/* continue le droulement du process np
	(si celui-ci avait t suspendu)	*/
void ContinueProcess(np)
	int	np;
	{
	if (present(np)) (sys->pid)[np]->fl=1;
	}

/* lit le pointeur vers le bloc de paramtres du sous-processus
	(pointeur pass par CreateSProcess)	*/
void *GetParam()
	{
	return (sys->sid)[sprocess]->param;
	}

/* retourne l'ID du n-ime processus */
int procn(n)
	int	n;
	{
		int	i;
		int	p;
	
	Bloque;
	p=sys->pro;
	for(i=0;i<n;i++) if(p!=Nid) p=(sys->pid)[p]->next;
	Debloque;
	return p;
	}

/* retourne l'ID du n-ime sous-processus */
int sprocn(n,p)
	int	n;
	int	p;
	{
		int	i;
		int	q;
		
	Bloque;
	if (!present(p))
		{
		Debloque;
		return Nid;
		}
	q=(sys->pid)[p]->spro;
	for(i=0;i<n;i++) if (q!=Nid) q=(sys->sid)[q]->next;
	Debloque;
	return q;
	}

/* rgle la minuterie du sous-processus pour qu'une comm 'horloge' soit reue n cycles plus tard */
void OnceRing(n)
	int	n;
	{
		sproc	q;
	q=(sys->sid)[sprocess];
	q->maskcomm|=CClock;
	q->clockn=clock()+n;
	q->flclock=-1;
	}

/* rgle la minuterie du sous-processus pour qu'une comm 'horloge' soit reue tous les n cycles */
void AlwaysRing(n)
	int	n;
	{
		sproc	q;
	q=(sys->sid)[sprocess];
	q->maskcomm|=CClock;
	q->clockn=clock()+n;
	q->flclock=n;
	}
