#include "desk.h"
/*	ROUTINES D'UTILISATION		*/

/*<<<<<	DEFINITION DE CASE	*/ 

/* dfinit une nouvelle case rectangulaire dans l'objet ob,
	(x,y)-(xx,yy) : coordonnes de la case
	typ	: si bit1=1, trace un cadre autour de la case (dans le work n)
	siz	: nombre de registres utilisateurs
	typc	: type de la case
	clk	: ID sous-processus pour rception du click
	zone	: ID sous-processus pour rception de 'entre de zone'	*/
cas newcvide(ob,n,x,y,xx,yy,typ,siz,typc,clk,zone)
	objet	ob;
	int	n,x,y,xx,yy,typ,siz,typc;
	int	clk,zone;
	{
		cas	c=newcase(ob);

	if (typ&2) box(ob,n,x-1,y-1,xx+1,yy+1,1);
	c->sizec=sizeof(struct Case)+(siz<<2);
	c->typc=typc;
	c->xcmn=x; c->ycmn=y; c->xcmx=xx; c->ycmx=yy;
	c->clk=clk; c->zone=zone;
	calceven(ob)->ncase++;
	afworkmodif(ob);
	return c;
	}

/* dfinit une nouvelle case rectangulaire dans l'objet ob, avec un texte dedans
	chn	: chane de caractres  afficher dans la case (utilisation du work n)
	(x,y)	: position de la case
	typ	: si bit1=1, trace un cadre autour de la case (dans le work n)
	siz	: nombre de registres utilisateurs
	typc	: type de la case
	clk	: ID sous-processus pour rception du click
	zone	: ID sous-processus pour rception de 'entre de zone'	*/
cas newc(ob,n,chn,x,y,typ,siz,typc,clk,zone)
	objet	ob;
	int	n;
	char	*chn;
	int	x,y,typ,siz,typc;
	int	clk,zone;
	{
		cas	c=newcase(ob);
		int	xm=x,lg,yb;
		char	ch;

	lg=calcworkn(ob,n)->fonte->larg;
	yb=y+calcworkn(ob,n)->fonte->haut;
	while(ch=*(chn++))
		{
		psetc(ob,n,x,y,ch,typ&1);
		x+=lg;
		}
	if (typ&2) box(ob,n,xm-1,y-1,x,yb,1);
	c->sizec=sizeof(struct Case)+(siz<<2);
	c->typc=typc;
	c->xcmn=xm; c->ycmn=y; c->xcmx=x-1; c->ycmx=yb-1;
	c->clk=clk; c->zone=zone;
	calceven(ob)->ncase++;
	afworkmodif(ob);
	return c;
	}

/* dfinition rapide d'une barre de menu pour l'objet ob :
	name : nom de la fentre
	endsp: ID d'un sous-processus pour recevoir le click sur la case 'destruction'
		la fonction retourne alors l'adresse de cette case
	      si =Nid, pas de case destruction
  cre aussi une grande case 'dplacement devant' (taille de la fentre)
  	et une autre 'dplacement derrire'		*/
cas setbarre(ob,name,endsp)
	objet	ob;
	char	*name;
	int	endsp;
	{
		cas	c=NULL;
		work	w=calcwork(ob);
		mainp	p=calcmainp(ob);
		int	xm=p->largo;
		int	y=w->fonte->haut+1;
		int	i=2;

	w->xwmn=1; w->ywmn=1; w->xwmx=xm-1; w->ywmx=p->hauto-1;
	newcvide(ob,0,0,0,p->largo,p->hauto,0,0,i,Nid,Nid);
	locate(ob,0,((xm-1)/w->fonte->larg-len(name))>>1,0);
	printchn(ob,0,name);
	line(ob,0,1,y,xm,y,1);
	if (endsp!=Nid) c=newc(ob,0," ",1,1,2,0,1,endsp,Nid);
	newc(ob,0,"X",p->largo-w->fonte->larg,1,2,0,6,Nid,Nid);
	w->ywmn+=y;
	w->xwmn++; w->ywmn++; w->xwmx--; w->ywmx--;
	locate(ob,0,0,0);
	afworkmodif(ob);
	return c;
	}

/* habillage standard de l'objet ob :
	barre de menu (et de 'dplacement devant')
	case de 'dplacement derrire'
	case de destruction
	ascenseurs vertical et horizontal
	case d'agrandissement
	case de travail pour 'inputchn()' : ce qui reste de la fentre
   paramtres :
	name : nom de la fentre
	endc : adresse d'un pointeur pour y stocker l'adresse de la case destruction
		(NULL => pas de case destruction)
	vert : pointeur vers l'entier qui contiendra la position de l'ascenseur vertical
		(NULL => pas d'ascenseur vertical)
	vertmax : pointeur vers l'entier qui contiendra la position maximale +1 de l'ascenseur
	hori : pointeur vers l'entier qui contiendra la position de l'ascenseur horizontal
		(NULL => pas d'ascenseur horizontal)
	horimax : pointeur vers l'entier qui contiendra la position maximale +1 de l'ascenseur
	typ : type des ascenseurs
	agrandc : adresse d'un pointeur pour y stocker l'adresse de la case agrandissement
		(NULL => pas de case agrandissement)
	fentravail : adresse d'un pointeur pour y stocker l'adresse de la case travail
		(NULL => pas de case travail)
   pour pouvoir utiliser les ascenseurs, il faut avoir dfini au moins 2 'work'	*/
void standard(ob,name,endc,vert,vertmax,hori,horimax,typ,agrandc,fentravail)
	objet	ob;
	char	*name;
	cas	*endc;
	int	*vert,*vertmax,*hori,*horimax,typ;
	cas	*agrandc;
	cas	*fentravail;
	{
		cas	c=NULL;
		work	w=calcwork(ob);
		mainp	p=calcmainp(ob);
		int	xm=p->largo,ym=p->hauto;
		int	y=w->fonte->haut+1;
	
	clearwind(ob);
	newcvide(ob,0,0,0,xm,y,0,0,2,Nid,Nid);
	locate(ob,0,((xm-1)/w->fonte->larg-len(name))>>1,0);
	printchn(ob,0,name);
	line(ob,0,1,y,xm,y,1);
	if (endc) *endc=newc(ob,0," ",1,1,2,0,1,sprocess,Nid);
	newc(ob,0,"X",p->largo-w->fonte->larg,1,2,0,6,Nid,Nid);
	
	if (ob->nwork<2) vert=hori=NULL;
	
	if ((agrandc)||((vert)&&(hori)))
		{
		if (agrandc) *agrandc=newcvide(ob,0,
				xm-8,ym-8,xm-1,ym-1,2,0,0,sprocess,Nid);
		w->ywmx-=9;
		if (vert)	{
			w->xwmx-=9;
			*vertmax=ym-26;
			vertlift(ob,1,xm-8,y+1,*vertmax,vert,typ);
			}
		if (hori)	{
			*horimax=xm-17;
			horilift(ob,1,1,ym-8,*horimax,hori,typ);
			}
		}
		else
		{
		if (vert)	{
			*vertmax=ym-17;
			vertlift(ob,1,xm-8,y+1,*vertmax,vert,typ);
			w->xwmx-=9;
			}
		if (hori)	{
			*horimax=xm-8;
			horilift(ob,1,1,ym-8,*horimax,hori,typ);
			w->ywmx-=9;
			}
		}
	w->xwmn++; w->ywmn+=y+1; w->xwmx--; w->ywmx--;
	if (fentravail) *fentravail=newcvide(ob,0,
			w->xwmn,w->ywmn,w->xwmx,w->ywmx,0,0,0,sprocess,Nid);
	locate(ob,0,0,0);
	afworkmodif(ob);
	}

/* gestion d'un menu droulant
	lg : largeur en caractres du menu
	n : nombre de lignes
	last : numro du dernier choix (0 si aucun)
	fonte : fonte  utiliser (NULL => fonte systme)
	puis les diffrents choix (chanes de caractre)
   retourne le numro du choix (0 si pas de choix)
   attention !! : certaines comm en attente dans la liste de rception peuvent disparatre */
int choix(int lg,int n,int last,font fonte,char *ch, ...)
	{
		int	dx,dy,x,y,i,j,state;
		long	mask;
		char	**p=&ch;
		char	chn[80];
		Mouse	m;
		objet	ob;
		long	t;

	if (fonte==NULL) fonte=sys->fontesys;
	dx=lg*fonte->larg+3;
	dy=n*fonte->haut+3;
	x=sys->xml-(dx>>1);
	y=sys->yml-(dy>>1);
	if (x<0) x=0;
	if (x+dx>sys->nbcl) x=sys->nbcl-dx;
	if (y<0) y=0;
	if (y+dy>sys->nbln) y=sys->nbln-dy;
	ob=newwind(dx,dy,x,y,0,0,n);
i=-2;
if (ob)	{
	calcwork(ob)->fonte=fonte;
	y=2;
	for (i=0;i<n;i++)
		{
		char *r, *q=chn;
		for (j=0;j<lg;j++) *(q++)=32; *q=0;
		q=chn; r=*(p++);
		if (last==i+1) *q='>';
		q++;
		while (*r) *(q++)=*(r++);
		newc(ob,0,chn,2,y,0,0,0,Nid,sprocess);
		y+=fonte->haut;
		}
	state=sys->state;
	mask=GetMaskComm();
	sys->state|=0x10;
	empile(ob,1);
	affobjet(ob);
	
	do	{
		t=WaitforComm(CEnter+CQuit+CClickE);
		if (t==CEnter)
			{
			GetEnter(&m);
			if (m.ob==ob) notcase(m.ob,m.ca);
			afworkmodif(ob);
			}
		if (t==CQuit)
			{
			GetQuit(&m);
			if (m.ob==ob) notcase(m.ob,m.ca);
			afworkmodif(ob);
			}
		}
	while (t!=CClickE);
	GetClickE(&m);
	i=-1;
	if ((m.ob==ob)&&(m.ca))
		i=(m.ca->ycmn-2)/fonte->haut;
	killob(ob);
	SetMaskComm(mask);
	sys->state=state;
	}
	return i+1;
	}

/* gestion d'un menu droulant appos sous la case c de l'objet ob
	lg : largeur en caractres du menu
	n : nombre de lignes
	last : numro du dernier choix (0 si aucun)
	fonte : fonte  utiliser (NULL => fonte systme)
	puis les diffrents choix (chanes de caractre)
   retourne le numro du choix (0 si pas de choix)
   attention !! : certaines comm en attente dans la liste de rception peuvent disparatre */
int menuder(objet obc,cas c,int lg,int n,int last,font fonte,char *ch, ...)
	{
		int	dx,dy,x,y,i,j,state;
		long	mask;
		char	**p=&ch;
		char	chn[80];
		Mouse	m;
		objet	ob;
		long	t;
	
	if (fonte==NULL) fonte=sys->fontesys;
	dx=lg*fonte->larg+3;
	dy=n*fonte->haut+3;
	x=calcmainp(obc)->xoe+c->xcmn-1;
	y=calcmainp(obc)->yoe+c->ycmx+1;
	if (x<0) x=0;
	if (x+dx>sys->nbcl) x=sys->nbcl-dx;
	if (y<0) y=0;
	if (y+dy>sys->nbln) y=sys->nbln-dy;
	ob=newwind(dx,dy,x,y,0,0,n);
i=-2;
if (ob)	{
	calcwork(ob)->fonte=fonte;
	y=2;
	for (i=0;i<n;i++)
		{
		char *r, *q=chn;
		for (j=0;j<lg;j++) *(q++)=32; *q=0;
		q=chn; r=*(p++);
		if (last==i+1) *q='>';
		q++;
		while (*r) *(q++)=*(r++);
		newc(ob,0,chn,2,y,0,0,0,Nid,sprocess);
		y+=fonte->haut;
		}
	state=sys->state;
	mask=GetMaskComm();
	sys->state|=0x10;
	empile(ob,1);
	affobjet(ob);
	
	do	{
		t=WaitforComm(CEnter+CQuit+CClickE);
		if (t==CEnter)
			{
			GetEnter(&m);
			if (m.ob==ob) notcase(m.ob,m.ca);
			afworkmodif(ob);
			}
		if (t==CQuit)
			{
			GetQuit(&m);
			if (m.ob==ob) notcase(m.ob,m.ca);
			afworkmodif(ob);
			}
		}
	while (t!=CClickE);
	GetClickE(&m);
	i=-1;
	if ((m.ob==ob)&&(m.ca))
		i=(m.ca->ycmn-2)/fonte->haut;
	killob(ob);
	SetMaskComm(mask);
	sys->state=state;
	}
	return i+1;
	}

/* gestion d'une fentre de confirmation :
	chn : texte  afficher dans la fentre
	annule = 0 : cases 'oui' et 'non'
	       > 0 : cases 'oui', 'non' et 'ignorer'
	       < 0 : case 'ok'
   retourne	1 : oui
	0 : non
	-1: ignorer ou ok
	-2: pas assez de mmoire pour ouvrir la fentre de confirmation	*/
int confirmation(chn,annule)
	char	*chn;
	int	annule;
	{
		objet	ob;
		work	w;
		cas	oui,non,ann=NULL;
		int	state,i=-2;
		long	mask;
		Mouse	m;
	
	ob=newwind(321,161,(sys->nbcl-320)>>1,(sys->nbln-160)>>1,0,0,3);
if (ob)	{
	w=calcwork(ob);	
	locate(ob,0,((w->xwmx-w->xwmn)/w->fonte->larg-len(chn))>>1,7); printchn(ob,0,chn);
	if (annule>=0)
		{
		oui=newc(ob,0,"  Oui  ",38+1,110,2,0,1,sprocess,Nid);
		non=newc(ob,0,"  Non  ",38*3+56*2+1,110,2,0,1,sprocess,Nid);
		}
	if (annule>0) ann=newc(ob,0,"Ignorer",38*2+56+1,110,2,0,1,sprocess,Nid);
	if (annule<0) ann=newc(ob,0,"  OK   ",38*3+56*2+1,110,2,0,1,sprocess,Nid);
	state=sys->state;
	sys->state|=16;
	mask=GetMaskComm();
	empile(ob,1);
	affobjet(ob);
	
	while(i==-2)
		{
		WaitforComm(CClickE);
		GetClickE(&m);
		if (annule>=0)
			{
			if (m.ca==oui) i=1;
			if (m.ca==non) i=0;
			}
		if ((annule)&&(m.ca==ann)) i=-1;
		}
	killob(ob);
	sys->state=state;
	SetMaskComm(mask);
	}
	return i;
	}

/* dfinit une case pour utiliser ensuite inputchn()
	si xn<0, ignore yn,xx,yx et cre une case aux dimensions du work (ob,n)
	si xn>=0 donne au work (ob,n) les nouvelles coordonnes (xn,yn)-(xx,yx) et cre
		une case  ces dimensions
	la case est cre avec le type typ		*/
cas DefCasInput(ob,n,xn,yn,xx,yx,typ)
	objet	ob;
	int	n,xn,yn,xx,yx,typ;
	{
		work	w=calcworkn(ob,n);

	if (xn>=0) console(ob,n,xn,yn,xx,yx);
	return newcvide(ob,n,w->xwmn,w->ywmn,w->xwmx,w->ywmx
		,typ,0,0,Nid,Nid);
	}

/* saisie d'une chane de caractres dans le work (ob,n)
	cs : case dans laquelle il faut cliquer pour rendre de nouveau le curseur actif.
	chn : pointeur vers le buffer dans lequel est stock la chane
	pt : nombre de caractres pr-dfinis dans le buffer au moment de l'appel de cette routine
		(vaut normalement 0) 
	ln : taille du buffer		*/
void inputchn(ob,n,cs,chn,pt,ln)
	objet	ob;
	int	n;
	cas	cs;
	char	*chn;
	int	pt,ln;
	{
		char	*p=chn;
		int	i,j,k,f,a;
		long	mask;
		Mouse	m;
		work	w=calcworkn(ob,n);
		long	t;
		
	for (i=0;i<pt;i++) print(ob,n,*(p++)); *p=0;
	cs->clk=sprocess;
	mask=GetMaskComm();
	chgcurseur(ob,n);
	ReceiveP(CChar); ReceiveSP(CChar);
	
	do	{
		k=0;
		t=WaitforComm(CClick+CChar);
		if (t==CClick)
			{
			GetClick(&m);
			if (m.ca==cs)
				{
				chgcurseur(ob,n);
				ReceiveP(CChar); ReceiveSP(CChar);
				}
			}
		if (t==CChar)
			{
			f=1;
			k=GetChar();
			if ((k>31)&&(pt<ln-1))
				{
				j=k;
				i=pt++;
				while((j)&&(i<ln-1))
					{
					a=chn[i]; chn[i++]=j; j=a;
					}
				chn[i]=0;
				print(ob,n,k);
				j=w->xcur; w->scroll=w->ycur;
				printchn(ob,n,&chn[pt]);
				locate(ob,n,j,w->scroll);
				f=0;
				}
			if ((k==0x1c)&&(pt>0))
				{
				print(ob,n,8);
				pt--;
				f=0;
				}
			if ((k==0x1d)&&(chn[pt]))
				{
				print(ob,n,9);
				pt++;
				f=0;
				}
			if ((k==8)&&(pt>0))
				{
				i=--pt;
				do	chn[i]=chn[i+1];
				while(chn[i++]);
				chn[--i]=32;
				print(ob,n,8);
				j=w->xcur; a=w->ycur;
				printchn(ob,n,&chn[pt]);
				locate(ob,n,j,a);
				chn[i]=0;
				f=0;
				}
			afworkmodif(ob);
			}
		}
	while(k!=13);
	printchn(ob,n,&chn[pt]);
	afworkmodif(ob);
	SetMaskComm(mask);
	}

/* fonction quivalente  fopen de ANSI	*/
FILE *Fopen(chn,typ)
	char	*chn,*typ;
	{
		File	f;
	
	f.nop=0;
	f.chn=chn;
	f.typ=typ;
	SendFile(&f,sys->psys);
	WaitforComm(CFile);
	GetFile(&f);
	return f.f;
	}

/* fonction quivalente  fclose de ANSI	*/
void Fclose(fil)
	FILE	*fil;
	{
		File	f;
	
	f.nop=1;
	f.f=fil;
	SendFile(&f,sys->psys);
	}

/* fonction quivalente  getc de ANSI	*/
char Getc(fil)
	FILE	*fil;
	{
		File	f;
	
	f.nop=2;
	f.f=fil;
	SendFile(&f,sys->psys);
	WaitforComm(CFile);
	GetFile(&f);
	return f.c;
	}

/* fonction quivalente  seek de ANSI	*/
void Fseek(fil,offs,orig)
	FILE	*fil;
	long	offs;
	int	orig;
	{
		File	f;
	
	f.nop=3;
	f.f=fil;
	f.pos=offs;
	f.err=orig;
	SendFile(&f,sys->psys);
	}

/* fonction quivalente  fread de ANSI	*/
long Fread(ptr,size,nmemb,fil)
	void	*ptr;
	long	size;
	long	nmemb;
	FILE	*fil;
	{
		File	f;
	
	f.nop=4;
	f.f=fil;
	f.chn=(char*)ptr;
	f.size=size;
	f.pos=nmemb;
	SendFile(&f,sys->psys);
	WaitforComm(CFile);
	GetFile(&f);
	return f.pos;
	}

/* fonction quivalente  fwrite de ANSI	*/
long Fwrite(ptr,size,nmemb,fil)
	void	*ptr;
	long	size;
	long	nmemb;
	FILE	*fil;
	{
		File	f;
	
	f.nop=5;
	f.f=fil;
	f.chn=(char*)ptr;
	f.size=size;
	f.pos=nmemb;
	SendFile(&f,sys->psys);
	WaitforComm(CFile);
	GetFile(&f);
	return f.pos;
	}

/* fonction quivalente  putc de ANSI	*/
int Putc(c,fil)
	int	c;
	FILE	*fil;
	{
		File	f;
	
	f.nop=6;
	f.f=fil;
	f.c=c;
	SendFile(&f,sys->psys);
	WaitforComm(CFile);
	GetFile(&f);
	return f.c;
	}

int spsyslift;

/* cration d'un ascenseur vertical dans le work (ob,n)
	(x,y) : coordonnes du coin suprieur gauche
		(la largeur de l'ascenseur est de 9 points)
	dy : valeur maximale +1 de l'entier li  l'ascenseur (=hauteur de l'ascenseur - 8)
	val : pointeur sur l'entier li  l'ascenseur
	typ =0 : une comm 'CPnt' est envoye lorsque l'utilisateur relche le bouton
	    <>0: une comm 'CPnt' est envoye pendant le dplacement du bouton	
	  la comm envoye contient l'adresse de la case ascenseur
	attention lors de la cration de l'objet (et dans le choix du nombre de cases)!! :
	une case ascenseur utilise 4 registres utilisateurs : 
		elle compte pour deux cases normales */
cas vertlift(ob,n,x,y,dy,val,typ)
	objet	ob;
	int	n,x,y,dy,*val,typ;
	{
		cas	c;
	
	c=newcvide(ob,n,x,y,x+7,y+dy+6,2,4,0,spsyslift,Nid);
	c->r[0]=(void*)val;
	c->r[1]=(void*)n;
	c->r[2]=(void*)sprocess;
	c->r[3]=(void*)typ;
	*val=0;
	box(ob,n,x,y+1,x+7,y+6,1);
	afworkmodif(ob);
	return c;
	}

/* cration d'un ascenseur horizontal dans le work (ob,n)
	(x,y) : coordonnes du coin suprieur gauche
		(la hauteur de l'ascenseur est de 9 points)
	dy : valeur maximale +1 de l'entier li  l'ascenseur (=largeur de l'ascenseur - 8)
	val : pointeur sur l'entier li  l'ascenseur
	typ =0 : une comm 'CPnt' est envoye lorsque l'utilisateur relche le curseur
	    <>0: une comm 'CPnt' est envoye pendant le dplacement du curseur
	  la comm envoye contient l'adresse de la case ascenseur
	attention lors de la cration de l'objet (et dans le choix du nombre de cases)!! :
	une case ascenseur utilise 4 registres utilisateurs : 
		elle compte pour deux cases normales */
cas horilift(ob,n,x,y,dx,val,typ)
	objet	ob;
	int	n,x,y,dx,*val,typ;
	{
		cas	c;
	
	c=newcvide(ob,n,x,y,x+dx+6,y+7,2,4,0,spsyslift,Nid);
	c->r[0]=(void*)val;
	c->r[1]=(void*)n;
	c->r[2]=(void*)sprocess;
	c->r[3]=(void*)typ;
	*val=0;
	box(ob,n,x+1,y,x+6,y+7,1);
	afworkmodif(ob);
	return c;
	}

/* sous-processus systme charg de la gestion des ascenseurs	*/
void liftsys()
	{
		long	k,l;
		Mouse	m;
		cas	c;
		Point	q;
		mainp	pp;
		int	*v,n,t,f;
		
	while(1)	
	  {
	  k=WaitforComm(CClick+CClickE);
	  if (k==CClick)
		{
		GetClick(&m);
		c=m.ca;
		f=0;
		if(c->xcmx-c->xcmn==7) f=1;
		pp=calcmainp(m.ob);
		v=(int*)c->r[0];
		n=(long)c->r[1];
		if ( ((!f)&&(m.dx>=*v)&&(m.dx<=7+*v))
			||((f)&&(m.dy>=*v)&&(m.dy<=7+*v))	)
		  {
		  ReceiveP(CMove); ReceiveSP(CMove);
		  do	{
			l=WaitforComm(CClickE+CMove);
			if (l==CMove)
				{
				while(GetMove(&q)==0);
				q.h-=pp->xoe;
				q.v-=pp->yoe;
				if ((f)&&(q.h>=c->xcmn-10)&&(q.h<=c->xcmx+10)
				  &&(q.v>=c->ycmn-6)&&(q.v<=c->ycmx+7))
				  {
				  box(m.ob,n,c->xcmn,c->ycmn+1+*v,
				  	c->xcmn+7,c->ycmn+6+*v,0);
				  t=q.v;
				  if (t<c->ycmn+4) t=c->ycmn+4;
				  if (t>c->ycmx-3) t=c->ycmx-3;
				  *v=t-c->ycmn-4;
				  box(m.ob,n,c->xcmn,c->ycmn+1+*v,
				  	c->xcmn+7,c->ycmn+6+*v,1);
				  afworkmodif(m.ob);
				  if(c->r[3])
				  	SendPoint((void*)v,(int)c->r[2]);
				  }
				if ((!f)&&(q.v>=c->ycmn-10)&&(q.v<=c->ycmx+10)
				  &&(q.h>=c->xcmn-6)&&(q.h<=c->xcmx+7))
				  {
				  box(m.ob,n,c->xcmn+1+*v,c->ycmn,
				  	c->xcmn+6+*v,c->ycmn+7,0);
				  t=q.h;
				  if (t<c->xcmn+4) t=c->xcmn+4;
				  if (t>c->xcmx-3) t=c->xcmx-3;
				  *v=t-c->xcmn-4;
				  box(m.ob,n,c->xcmn+1+*v,c->ycmn,
				  	c->xcmn+6+*v,c->ycmn+7,1);
				  afworkmodif(m.ob);
				  if(c->r[3])
				  	SendPoint((void*)v,(int)c->r[2]);
				  }
				}
			}
		  while(l!=CClickE);
		  GetClickE(&m);
		  if(!c->r[3])
		  	SendPoint((void*)v,(int)c->r[2]);
		  }
		}
	if (k==CClickE) GetClickE(&m);
	  }
	}

/* sous-processus systme charg de la gestion des fichiers		*/
void filesys()
	{
		Comm	c;
		int	k,i;
		File	*f;

	for(k=0;k<nmaxfil;k++) (sys->filep)[k]=Nid;
	ReceiveSP(CFile);
	while(1)	{
		WaitforComm(CFile);
		GetComm(&c,CFile);
		f=&c.data.f;
		k=f->nop;
		f->err=0;
		if (k==0)	{
			i=0;
			while((i<nmaxfil)&&((sys->filep)[i]!=Nid)) i++;
			if (i==nmaxfil)
				{
				f->err=-4;
				f->f=NULL;
				SendError(-4,sys->psys);
				}
				else
				{
				f->f=fopen(f->chn,f->typ);
				if (!f->f)	f->err=-2;
					else
					{
					(sys->Fl)[i]=f->f;
					(sys->filep)[i]=c.np;
					}
				}
			SendFile(f,c.nsp);
			}
		if (k==1)	{
			for(i=0;i<nmaxfil;i++) if ((sys->Fl)[i]==f->f) (sys->filep)[i]=Nid;
			fclose(f->f);
			}
		if (k==2)	{
			f->c=getc(f->f);
			SendFile(f,c.nsp);
			}
		if (k==3)	{
			fseek(f->f,f->pos,f->err);
			}
		if (k==4)	{
			f->pos=fread((void*)f->chn,f->size,f->pos,f->f);
			SendFile(f,c.nsp);
			}
		if (k==5)	{
			f->pos=fwrite((void*)f->chn,f->size,f->pos,f->f);
			SendFile(f,c.nsp);
			}
		if (k==6)	{
			f->c=putc(f->c,f->f);
			SendFile(f,c.nsp);
			}
		}
	}

/* sous-processus systme comptable des erreurs systme	*/
void errorsys()
	{
		objet	ob;
		Comm	c;
		cas	endc;
		int	k;
		Mouse	m;
	
	ReceiveSP(CError);
	ob=newwind(300,300,0x8000,0,0,0,10);
	endc=setbarre(ob,"Erreurs Systeme",sprocess);
	
	while(1)	{
		k=WaitforComm(CClickE+CError);
		if (k==CClickE)
			{
			GetClickE(&m);
			if (m.ca==endc)
				{
				depile(ob);
				affobjet(ob);
				}
			}
		if (k==CError)
			{
			GetComm(&c,CError);
			if (k=c.data.i)
				{
				printchn(ob,0,"] PROCESS ");
				printhexint(ob,0,(int)c.np);
				printchn(ob,0,", SPROCESS ");
				printhexint(ob,0,(int)c.nsp);
				println(ob,0,"");
				if (k==-1) println(ob,0,
					" MEMOIRE INSUFFISANTE");
				if (k==-4) println(ob,0,
					" PLUS DE CANAL LIBRE");
				}
			depile(ob); empile(ob,1);
			chgcurseur(ob,0);
			affobjet(ob);
			}
		}
	}	

/* sous-processus installant les sous-processus systme	*/
void sproc1sys()
	{
	CreateSProcess(errorsys,256,2048,NULL);
	CreateSProcess(filesys,256,2048,NULL);
	spsyslift=CreateSProcess(liftsys,256,2048,NULL);
	EndSProcess();
	}

